
--BEFORE CODE 20.04.2016

--  LINK_VKR  CALCULATE_JURNAL
IF COLUMNPROPERTY(object_id('[dbo].[CALCULATE_JURNAL]'), 'LINK_VKR2', 'AllowsNull') is NULL
   ALTER TABLE [dbo].[CALCULATE_JURNAL] ADD [LINK_VKR2] int NULL 
GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX_CALCULATE_JURNAL_VKR2')
CREATE INDEX [IX_CALCULATE_JURNAL_VKR2] ON [dbo].[CALCULATE_JURNAL] ([LINK_VKR2]) ON [INDEX]
GO

IF  NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id('dbo.[FK_CALCULATE_JURNAL_SAL_SFIN2]'))
ALTER TABLE [dbo].[CALCULATE_JURNAL] 
ADD CONSTRAINT [FK_CALCULATE_JURNAL_SAL_SFIN2] FOREIGN KEY ([LINK_VKR2]) REFERENCES [dbo].[SAL_SFIN] ([LINK])
GO

ALTER TABLE [dbo].[CALCULATE_JURNAL] DISABLE TRIGGER ALL
GO

UPDATE J SET J.LINK_VKR2 = J.LINK_VKR
FROM
	dbo.CALCULATE_JURNAL J
	INNER JOIN dbo.SDOC S ON J.LINK_DOC = S.LINK
	INNER JOIN dbo.S_OBJECTS SO ON SO.LINK = S.[OBJECT]
WHERE
	SO.CODE = 'DOCUMENTS_DEDUCT_ESN_G'	
	AND
	J.LINK_VKR2 IS NULL	
GO

ALTER TABLE [dbo].[CALCULATE_JURNAL] ENABLE TRIGGER ALL
GO


--  LINK_VKR2  SDOC_DOT_SKIDKI
IF COLUMNPROPERTY(object_id('[dbo].[SDOC_DOT_SKIDKI]'), 'LINK_VKR2', 'AllowsNull') is NULL
   ALTER TABLE [dbo].[SDOC_DOT_SKIDKI] ADD [LINK_VKR2] int NULL 
GO

ALTER TABLE [dbo].[SDOC_DOT_SKIDKI] DISABLE TRIGGER ALL
GO

UPDATE [dbo].[SDOC_DOT_SKIDKI] SET [LINK_VKR2] = [LINK_VKR] WHERE [LINK_VKR2] IS NULL
GO

ALTER TABLE [dbo].[SDOC_DOT_SKIDKI] ENABLE TRIGGER ALL
GO

IF  NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id('dbo.[FK_SDOC_DOT_SKIDKI_SAL_SFIN]'))
ALTER TABLE [dbo].[SDOC_DOT_SKIDKI] 
ADD CONSTRAINT [FK_SDOC_DOT_SKIDKI_SAL_SFIN] FOREIGN KEY ([LINK_VKR2]) REFERENCES [dbo].[SAL_SFIN] ([LINK])
GO

--  LINK_VKR2  SDOC_DOT_VYCHET
IF COLUMNPROPERTY(object_id('[dbo].[SDOC_DOT_VYCHET]'), 'LINK_VKR2', 'AllowsNull') is NULL
   ALTER TABLE [dbo].[SDOC_DOT_VYCHET] ADD [LINK_VKR2] int NULL 
GO

ALTER TABLE [dbo].[SDOC_DOT_VYCHET] DISABLE TRIGGER ALL
GO

UPDATE [dbo].[SDOC_DOT_VYCHET] SET [LINK_VKR2] = [LINK_VKR] WHERE [LINK_VKR2] IS NULL
GO

ALTER TABLE [dbo].[SDOC_DOT_VYCHET] ENABLE TRIGGER ALL
GO

IF  NOT EXISTS (SELECT * FROM dbo.sysconstraints WHERE constid =  object_id('dbo.[FK_SDOC_DOT_VYCHET_SAL_SFIN]'))
ALTER TABLE [dbo].[SDOC_DOT_VYCHET] 
ADD CONSTRAINT [FK_SDOC_DOT_VYCHET_SAL_SFIN] FOREIGN KEY ([LINK_VKR2]) REFERENCES [dbo].[SAL_SFIN] ([LINK])
GO


GO

--PROC, VIEW, FUNC 20.04.2016
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[DOCUMENTS_DED_OTHER_TABLE]') AND OBJECTPROPERTY(id, N'IsView') = 1)
DROP VIEW dbo.[DOCUMENTS_DED_OTHER_TABLE]

GO

CREATE VIEW dbo.DOCUMENTS_DED_OTHER_TABLE
AS

SELECT
	[LINK]		= SD.LINK_UP,
	[ORDERS]	= SD.ORDERS,
	[CODE_DED]	= P.CODE,
	[NAME_DED]	= P.[NAME],
	[REF_DED]	= SD.LINK_PAY,
	[LINK_VKR]	= SD.LINK_VKR,
	[NAME_VKR]	= F.CODE,
	[LINK_EKR]	= SD.LINK_EKR,
	[NAME_EKR]	= G.CODE,
	[SUMMA_BASE]	= SD.SUMMA_BASE,
	[PERCENT]	= SD.PERC,
	[SUMMA]		= SUM(SD.SUMMA),
	[SKIDKA] = SUM(ISNULL(S.SUMMA,0)),
	[VYCHET] = SUM(ISNULL(S2.SUMMA,0)),
	[LINK_VKR2]	= SD.LINK_VKR2,
	[NAME_VKR2]	= F2.CODE
FROM 	
	dbo.SDOC_DOT_TABLE SD 
	INNER JOIN dbo.PAYS P ON SD.LINK_PAY = P.LINK
	INNER JOIN dbo.SAL_SFIN	F ON F.LINK = SD.LINK_VKR
	INNER JOIN dbo.KOSGU G ON G.LINK = SD.LINK_EKR
	LEFT JOIN dbo.SAL_SFIN	F2 ON F2.LINK = SD.LINK_VKR2
	LEFT JOIN 
	(  	SELECT 
			LINK_UP, LINK_TAX, LINK_VKR, LINK_VKR2, LINK_EKR, [PERCENT], SUMMA = SUM(SUMMA)
		FROM
			dbo.SDOC_DOT_SKIDKI
		GROUP BY
			LINK_UP, LINK_TAX, LINK_VKR, LINK_VKR2, LINK_EKR, [PERCENT]	
	) S ON S.LINK_UP = SD.LINK_UP AND S.LINK_TAX = SD.LINK_PAY AND S.LINK_VKR = SD.LINK_VKR AND S.LINK_VKR2 = SD.LINK_VKR2 AND S.LINK_EKR = SD.LINK_EKR AND S.[PERCENT] = SD.PERC
	LEFT JOIN 
	(  	SELECT 
			LINK_UP, LINK_TAX, LINK_VKR, LINK_VKR2, LINK_EKR, [PERCENT], SUMMA = SUM(SUMMA)
		FROM
			dbo.SDOC_DOT_VYCHET
		GROUP BY
			LINK_UP, LINK_TAX, LINK_VKR, LINK_VKR2, LINK_EKR, [PERCENT]	
	) S2 ON S2.LINK_UP = SD.LINK_UP AND S2.LINK_TAX = SD.LINK_PAY AND S2.LINK_VKR = SD.LINK_VKR AND S2.LINK_VKR2 = SD.LINK_VKR2 AND S.LINK_EKR = SD.LINK_EKR  AND S2.[PERCENT] = SD.PERC
GROUP BY
	SD.LINK_UP,
	SD.ORDERS,
	P.CODE,
	P.[NAME],
	SD.LINK_PAY,
	SD.LINK_VKR,
	F.CODE,
	SD.LINK_EKR,	
	G.CODE,	
	SD.SUMMA_BASE,
	SD.PERC,
	SD.LINK_VKR2,
	F2.CODE	


GO


GRANT SELECT ON dbo.[DOCUMENTS_DED_OTHER_TABLE] TO PUBLIC

GO

GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SDOC_DOT_VYCHET_FIO]') AND OBJECTPROPERTY(id, N'IsView') = 1)
DROP VIEW dbo.[SDOC_DOT_VYCHET_FIO]

GO

CREATE VIEW dbo.SDOC_DOT_VYCHET_FIO
AS
SELECT 
	LINK = LINK_UP,
	ORDERS = LEFT(RTRIM(P.FM) + ' ' + SUBSTRING(RTRIM(P.IM),1,1) + '.' + SUBSTRING(RTRIM(P.OT),1,1) + '.',120),
	LINK_TAX,
	LINK_DED,
	CODE_DED = D.SNAME,
	S.LINK_PERS,
	FIO = LEFT(RTRIM(P.FM) + ' ' + SUBSTRING(RTRIM(P.IM),1,1) + '.' + SUBSTRING(RTRIM(P.OT),1,1) + '.',120),
	S.LINK_VKR,
	CODE_S_FIN = F.CODE,
	S.LINK_VKR2,
	S.LINK_EKR,
	CODE_EKR = G.CODE,
	S.[PERCENT],
	S.SUMMA
FROM 
	[dbo].[SDOC_DOT_VYCHET] S
	INNER JOIN dbo.PERSON P ON P.LINK = S.LINK_PERS
	INNER JOIN dbo.DICTIONARY_TYP_DEDUCTION D ON D.LINK = S.LINK_DED
	INNER JOIN dbo.SAL_SFIN F ON F.LINK = S.LINK_VKR
	INNER JOIN dbo.KOSGU G ON G.LINK = S.LINK_EKR



GO


GRANT SELECT ON dbo.[SDOC_DOT_VYCHET_FIO] TO PUBLIC

GO

GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[S_J_C_Short]') AND OBJECTPROPERTY(id, N'IsView') = 1)
DROP VIEW dbo.[S_J_C_Short]

GO

CREATE    VIEW dbo.S_J_C_Short

AS
SELECT
[LINK]			= JC.LINK,
[LINK_EMPL] 	=JC.LINK_EMPL,
LINK_SOVM		= COALESCE(JC.LINK_SOVM,0),	
[LINK_FACE] 	= E.PERS_LINK,
[LINK_PAYS]		= P.LINK,
[CODE_PAYS]		= P.CODE,
[NAME_PAYS]		= P.NAME,
[TYP_PER]		= P.TYP_PER,
[F14]				= P.F14,
[WAY_CALC] 		= P.WAY_CALC,
[MONTH_BEGIN]	= MONTH(JC.PERIOD_BEGIN),
[YEAR_BEGIN]	= YEAR(JC.PERIOD_BEGIN),
[PERIOD_BEGIN]	= JC.PERIOD_BEGIN,
[MONTH_END] 	= MONTH(PERIOD_END),
[YEAR_END]		= YEAR(PERIOD_END),
[PERIOD_END] 	= JC.PERIOD_END,
[HOURS]			= JC.HOURS,
[DAYS]			= JC.DAYS,
[SUMMA_BASE]	= JC.SUMMA_BASE,
[SUMMA]			= JC.SUMMA,
[LINK_DOC]		= JC.LINK_DOC,
[ORDERS]		= JC.ORDERS,
[DATE1]			= JC.DATE_BEGIN,
[DATE2]			= JC.DATE_END,
[LINK_INC] 		= P.LINK_INC,
[TYP_OPER]  	= P.OBJECT,
[LINK_VKR] 		= JC.LINK_VKR,
[LINK_EKR] 		= COALESCE(JC.LINK_EKR,P.LINK_EKR),
[LINK_ORG]		= JC.LINK_ORG,
[PERS_LINK]		= JC.PERS_LINK,
[LINK_DEP]		= JC.LINK_DEP,
[LINK_VKR2] 		= JC.LINK_VKR2	
FROM dbo.CALCULATE_JURNAL JC LEFT JOIN dbo.EMPL E 	ON JC.LINK_EMPL = E.LINK ----AND E.DEP_LINK = dbo.GetUserDepLink()
LEFT JOIN  PAYS P ON JC.LINK_PAYS = P.LINK



GO


GRANT SELECT ON dbo.[S_J_C_Short] TO PUBLIC

GO


-- --


GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SDOC_DOT_SKIDKI_FIO]') AND OBJECTPROPERTY(id, N'IsView') = 1)
DROP VIEW dbo.[SDOC_DOT_SKIDKI_FIO]
GO

CREATE VIEW dbo.SDOC_DOT_SKIDKI_FIO
AS
SELECT 
	LINK = LINK_UP,
	ORDERS = LEFT(RTRIM(P.FM) + ' ' + SUBSTRING(RTRIM(P.IM),1,1) + '.' + SUBSTRING(RTRIM(P.OT),1,1) + '.',120),
	LINK_TAX,
	LINK_INC,
	CODE_INC = D.SNAME,
	S.LINK_PERS,
	FIO = LEFT(RTRIM(P.FM) + ' ' + SUBSTRING(RTRIM(P.IM),1,1) + '.' + SUBSTRING(RTRIM(P.OT),1,1) + '.',120),
	S.LINK_VKR,
	CODE_S_FIN = F.CODE,
	S.LINK_VKR2,
	S.LINK_EKR,
	CODE_EKR = G.CODE,
	S.[PERCENT],
	S.SUMMA
FROM 
	[dbo].[SDOC_DOT_SKIDKI] S
	INNER JOIN dbo.PERSON P ON P.LINK = S.LINK_PERS
	INNER JOIN dbo.DICTIONARY_TYP_INCOMS D ON D.LINK = S.LINK_INC
	INNER JOIN dbo.SAL_SFIN F ON F.LINK = S.LINK_VKR
	INNER JOIN dbo.KOSGU G ON G.LINK = S.LINK_EKR


GO


GRANT SELECT ON dbo.[SDOC_DOT_SKIDKI_FIO] TO PUBLIC

GO

GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SD_O_OTHER_FILL]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[SD_O_OTHER_FILL]

GO

CREATE   PROCEDURE dbo.SD_O_OTHER_FILL
@LINK INT
AS  

DECLARE @Month int, 
		@Year int, 
		@Link1 int,
		@DEP_LINK INT,
		@Date DATETIME	

SELECT 
	@Year = YEAR(S.DATE_CALC),
	@Month = MONTH(S.DATE_CALC),
	@DEP_LINK = S.LINK_DEP,
	@Date = dbo.DATEENDOFMONTH(S.DATE_CALC)
FROM 
	dbo.SDOC S
WHERE 
	S.LINK = @LINK

IF @DEP_LINK IS NULL
	Set @DEP_LINK = Coalesce( (SELECT TOP 1 ZB_LINK FROM dbo.KS_OPTIONS_ZB), dbo.GetOwnDepLink())

--- 
--!!!         .    
CREATE TABLE #RANGE(LINK_PAYS INT, PREDEL NUMERIC(18,2), [PERCENT] NUMERIC(18,2))
INSERT INTO #RANGE (LINK_PAYS, PREDEL,  [PERCENT])
SELECT 
	DR.LINK_PAYS, PREDEL, [PERCENT]
FROM 
	dbo.PAYS P
	INNER JOIN dbo.DICTIONARY_RANGE DR ON P.LINK = DR.LINK_PAYS
WHERE
	P.[OBJECT] = 3 AND P.WAY_CALC = 5
	AND TARIF = 1
	AND DR.[DATE]= (SELECT TOP 1 [DATE] FROM dbo.DICTIONARY_RANGE DR1 
		WHERE DR1.TARIF = DR.TARIF AND LINK_PAYS = P.LINK AND [DATE] <= @Date ORDER BY [DATE] DESC) 	

DECLARE @COLUMN_REF_PAY_MROT_T3 INT
SET @COLUMN_REF_PAY_MROT_T3 = (SELECT TOP 1 LINK FROM dbo.S_OBJECTS WHERE CODE = 'COLUMN_REF_PAY_MROT_T3')

----    
CREATE TABLE #INV ([PERCENT] NUMERIC(18,2), LINK INT)
INSERT  INTO #INV ([PERCENT], LINK)
SELECT
	[PERCENT] = MP.summa, I.PERS_LINK
FROM	
	dbo.MINROT_PAYS MP
	INNER JOIN dbo.PERS_INVALID I ON 1=1
WHERE
	[OBJECT] = @COLUMN_REF_PAY_MROT_T3
	AND
	LINK_MINROT = (SELECT TOP 1 LINK FROM MINROT WHERE PERIOD<=@Date ORDER BY PERIOD DESC)
	AND
	dbo.DateEndOfMonth(dbo.ConvertDMY2Date(1,@Month,@Year))
		BETWEEN I.DATE_BEGIN AND COALESCE(I.DATE_END,'29990101')	

--===ר 
--    
CREATE TABLE #SKIDKA (LINK_INC INT, PREDEL NUMERIC(18,2))
INSERT INTO #SKIDKA (LINK_INC, PREDEL)
SELECT TI.LINK, D.PREDEL
FROM 
	dbo.Salary_deduct_esn(@Date) D	
	INNER JOIN dbo.DICTIONARY_TYP_INCOMS TI ON TI.REF_DEDUCT = D.REF_PAY
	AND dbo.SA_GET_OPTION_BY_CODE('ESNTR_OPTIONS_OPT3') = 1 --   
	
-- 
CREATE TABLE #BASE (LINK_TAX INT, LINK_PAY INT)
INSERT INTO #BASE (LINK_TAX, LINK_PAY)
SELECT T.LINK_TAX, T.LINK_PAYS 
FROM
	dbo.PAYS P  
	INNER JOIN dbo.TAX_REF T ON T.LINK_TAX = P.LINK
WHERE
	P.[OBJECT] = 3 AND P.WAY_CALC = 5	

--         
DECLARE @LINK_EKR211 INT, @LINK_EKR212 INT, @LINK_EKR213 INT
SET @LINK_EKR211 = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '211')
SET @LINK_EKR212 = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '212')
SET @LINK_EKR213 = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '213')

DECLARE @SALARY_PROV_OPT4 TINYINT
SET @SALARY_PROV_OPT4 = dbo.sa_get_option_by_code('SALARY_PROV_OPT4')

CREATE TABLE #SUMMA (LINK_TAX INT, LINK_PERS INT, LINK_INC INT, LINK_VKR INT, LINK_EKR INT, SUMMA_M NUMERIC(18,2),SUMMA NUMERIC(18,2), LINK_VKR2 INT)
INSERT INTO #SUMMA (LINK_TAX, LINK_PERS, LINK_INC, LINK_VKR, LINK_EKR, SUMMA_M, SUMMA, LINK_VKR2)
SELECT
	B.LINK_TAX,
	ISNULL(J.PERS_LINK,E.PERS_LINK),
	P.LINK_INC,
	LINK_VKR = ISNULL(SF.LINK_SS_SFIN,J.LINK_VKR),
	CASE WHEN @SALARY_PROV_OPT4 = 0 THEN 
		CASE WHEN COALESCE(J.LINK_EKR,@LINK_EKR213) = @LINK_EKR211 THEN @LINK_EKR213 ELSE COALESCE(J.LINK_EKR,@LINK_EKR213) END
	ELSE 
		CASE WHEN COALESCE(J.LINK_EKR,@LINK_EKR213) IN (@LINK_EKR211, @LINK_EKR212) THEN @LINK_EKR213 ELSE COALESCE(J.LINK_EKR,@LINK_EKR213) END				
	END,	
	SUMMA_M = SUM(CASE WHEN MONTH(J.PERIOD_BEGIN) = @Month THEN SUMMA ELSE 0 END),
	SUMMA  = SUM(SUMMA),
	LINK_VKR2 = J.LINK_VKR
FROM
	#BASE B 
	INNER JOIN dbo.PAYS P ON P.LINK = B.LINK_PAY
	INNER JOIN dbo.CALCULATE_JURNAL J ON J.LINK_PAYS = P.LINK
	INNER JOIN dbo.EMPL E ON E.LINK = J.LINK_EMPL
	INNER JOIN dbo.SAL_SFIN SF ON SF.LINK = J.LINK_VKR
WHERE
	J.LINK_DEP = @DEP_LINK
	AND
	P.[OBJECT] = 1 
	AND
	YEAR(J.PERIOD_BEGIN) = @Year AND MONTH(J.PERIOD_BEGIN) <= @Month
	--AND
	--J.LINK_EKR <> @LINK_EKR213
GROUP BY
	B.LINK_TAX, ISNULL(J.PERS_LINK,E.PERS_LINK), P.LINK_INC, LINK_VKR, J.LINK_EKR, SF.LINK_SS_SFIN

		
--        
CREATE TABLE #SUMMA2 (LINK_TAX INT, LINK_PERS INT, LINK_INC INT, SUMMA_M NUMERIC(18,2), SUMMA NUMERIC(18,2))
INSERT INTO #SUMMA2 (LINK_TAX, LINK_PERS, LINK_INC, SUMMA_M, SUMMA)
SELECT LINK_TAX, LINK_PERS, LINK_INC, SUM(SUMMA_M), SUM(SUMMA)
FROM #SUMMA
GROUP BY LINK_TAX, LINK_PERS, LINK_INC

--     ,    
DELETE FROM dbo.SDOC_DOT_SKIDKI WHERE LINK_UP = @LINK

--           
CREATE TABLE #SKIDKA_PREV (LINK_TAX INT, LINK_PERS INT, LINK_INC INT, SUMMA NUMERIC(18,2))

INSERT INTO #SKIDKA_PREV (LINK_TAX, LINK_PERS, LINK_INC, SUMMA)
SELECT LINK_TAX, LINK_PERS, LINK_INC, SUM(SUMMA)
FROM 
	dbo.SDOC D
	INNER JOIN dbo.SDOC_DOT_SKIDKI S ON S.LINK_UP = D.LINK
WHERE
	D.LINK_DEP = @DEP_LINK
	AND 
	YEAR(DATE_CALC)	= @Year AND MONTH(DATE_CALC) < @Month
GROUP BY
	LINK_TAX, LINK_PERS, LINK_INC

--
DECLARE @ESNTR_OPTIONS_OPT5 INT
SET @ESNTR_OPTIONS_OPT5 = dbo.SA_GET_OPTION_BY_CODE('ESNTR_OPTIONS_OPT5')

--     
CREATE TABLE #PREV_DED (LINK_PERS INT, LINK_INC INT, SUMMA NUMERIC(18,2))
--
INSERT INTO #PREV_DED (LINK_PERS, LINK_INC, SUMMA)
SELECT E.PERS_LINK, LINK_INC = T.LINK, SUMMA = SUM(PD.SUMMA_DED)
FROM 
	dbo.SD_EMPL_PREV_DED PD
	INNER JOIN dbo.DICTIONARY_TYP_INCOMS T with (nolock) ON T.REF_DEDUCT = PD.LINK_DED
	INNER JOIN dbo.EMPL E with (nolock) ON E.LINK = PD.LINK_EMPL
	INNER JOIN dbo.ITEM_MOVE IM with (nolock) ON IM.EMPL_LINK = E.LINK AND IM.ACTIVE = 1 AND IM.NEW_FACE=1 AND IM.[STATUS] IN (1,3) AND IM.DATE_BEGIN <= @Date
	INNER JOIN (
		SELECT E.PERS_LINK, MAX(DATE_BEGIN) AS DATE_BEGIN
		FROM 
			dbo.EMPL E with (nolock)
			INNER JOIN dbo.ITEM_MOVE IM with (nolock) ON IM.EMPL_LINK = E.LINK AND IM.ACTIVE = 1 AND IM.NEW_FACE=1 AND IM.[STATUS] IN (1,3) AND IM.DATE_BEGIN <= @Date
			LEFT JOIN DBO.ITEM_DIS_FACE IDF with (nolock) ON IDF.EMPL_LINK = E.LINK AND IDF.ACTIVE=1 AND COALESCE(IDF.DIS_DATE,'20990101') >= dbo.DateBeginOfMonth(@Date)	
		GROUP BY
			E.PERS_LINK	
	) A ON A.PERS_LINK = E.PERS_LINK AND A.DATE_BEGIN = IM.DATE_BEGIN
WHERE
	E.DEP_LINK = @DEP_LINK
	AND
	YEAR(IM.DATE_begin) = @Year --YEAR(dbo.kd_DateBeginWork(@linkEmpl,null)) = @Year
	AND
	@ESNTR_OPTIONS_OPT5 = 1 -- ,     
GROUP BY
	E.PERS_LINK, T.LINK

--            
INSERT INTO dbo.SDOC_DOT_SKIDKI (LINK_UP, LINK_TAX, LINK_PERS, LINK_INC, LINK_VKR, LINK_VKR2, LINK_EKR, SUMMA, [PERCENT])
SELECT 
	@LINK, S2.LINK_TAX, S2.LINK_PERS, S2.LINK_INC, S.LINK_VKR, S.LINK_VKR2, S.LINK_EKR,
	--     
	--CASE WHEN S2.SUMMA_M > CASE WHEN ISNULL(SP.SUMMA,0) < SK.PREDEL THEN (SK.PREDEL - ISNULL(SP.SUMMA,0)) * (S.SUMMA_M / S2.SUMMA_M) ELSE 0 END
	--	THEN CASE WHEN ISNULL(SP.SUMMA,0) < SK.PREDEL THEN (SK.PREDEL - ISNULL(SP.SUMMA,0)) * (S.SUMMA_M / S2.SUMMA_M) ELSE 0 END
	--	ELSE S2.SUMMA_M
	--END,
	(
		CASE WHEN
			--  
			(CASE WHEN ISNULL(PD.SUMMA,0) + ISNULL(S2.SUMMA,0) > ISNULL(SK.PREDEL,0) THEN ISNULL(SK.PREDEL,0) ELSE ISNULL(PD.SUMMA,0) + ISNULL(S2.SUMMA,0) END) > 0 
		THEN
		(
			--  
			(CASE WHEN ISNULL(PD.SUMMA,0) + ISNULL(S2.SUMMA,0) > ISNULL(SK.PREDEL,0) THEN ISNULL(SK.PREDEL,0) ELSE ISNULL(PD.SUMMA,0) + ISNULL(S2.SUMMA,0) END) 
			-- 
			- ISNULL(SP.SUMMA,0) - ISNULL(PD.SUMMA,0)
		)	
			----  
			* (S.SUMMA_M / S2.SUMMA_M)
		ELSE
		0 
		END	
	),
	[PERCENT] = ISNULL(I.[PERCENT],DR.[PERCENT])
FROM 
	#RANGE DR -- 
	INNER JOIN #SUMMA2 S2 ON --        
							S2.LINK_TAX = DR.LINK_PAYS
	INNER JOIN #SUMMA S ON --         
							S.LINK_TAX = S2.LINK_TAX AND S.LINK_PERS = S2.LINK_PERS AND S.LINK_INC = S2.LINK_INC
	INNER JOIN #SKIDKA SK ON --    
							SK.LINK_INC = S.LINK_INC
	LEFT JOIN #SKIDKA_PREV SP ON --           
							SP.LINK_TAX = S2.LINK_TAX AND SP.LINK_PERS = S2.LINK_PERS AND SP.LINK_INC = S2.LINK_INC
	LEFT JOIN #PREV_DED PD ON --     
						PD.LINK_PERS = S2.LINK_PERS AND PD.LINK_INC = S2.LINK_INC								
	LEFT JOIN #INV I ON --    
						I.LINK = S2.LINK_PERS
WHERE
	S2.SUMMA_M <> 0
	

--===ר 
--    
CREATE TABLE #VYCHET (LINK_DED INT, PREDEL NUMERIC(18,2))
INSERT INTO #VYCHET (LINK_DED, PREDEL)
SELECT TI.LINK, D.PREDEL
FROM 
	dbo.Salary_deduct_esn(@Date) D	
	INNER JOIN dbo.DICTIONARY_TYP_DEDUCTION TI ON TI.LINK = D.REF_PAY
	LEFT JOIN dbo.DICTIONARY_TYP_INCOMS TI2 ON TI2.REF_DEDUCT = D.REF_PAY
WHERE 
	TI2.REF_DEDUCT IS NULL
	AND
	dbo.SA_GET_OPTION_BY_CODE('ESNTR_OPTIONS_OPT4') = 1 --  		
	
--  ,     
CREATE TABLE #SUMMA_U (LINK_DED INT, LINK_PERS INT, SUMMA_M NUMERIC(18,2), SUMMA NUMERIC(18,2))
INSERT INTO #SUMMA_U (LINK_DED, LINK_PERS, SUMMA_M, SUMMA)
---  
SELECT 
	TA.LINK_DED, ISNULL(J.PERS_LINK,E.PERS_LINK), 
	SUMMA_M = SUM(CASE WHEN MONTH(J.PERIOD_BEGIN) = @Month THEN SUMMA ELSE 0 END),
	SUMMA  = SUM(SUMMA)
FROM 
	dbo.EMPL E inner join dbo.calculate_jurnal J ON e.link = J.link_empl
	inner join dbo.TAX2_APP TA ON TA.LINK_UP = J.LINK_PAYS
WHERE 
	J.LINK_DEP = @DEP_LINK
	AND YEAR(J.PERIOD_BEGIN) = @Year AND MONTH(J.PERIOD_BEGIN) <= @Month
	AND ISNULL(TA.LINK_DED,0) > 0
GROUP BY 
	TA.LINK_DED, ISNULL(J.PERS_LINK,E.PERS_LINK)

--     ,    
DELETE FROM dbo.SDOC_DOT_VYCHET WHERE LINK_UP = @LINK	

--           
CREATE TABLE #VYCHET_PREV (LINK_TAX INT, LINK_PERS INT, LINK_DED INT, SUMMA NUMERIC(18,2))

INSERT INTO #VYCHET_PREV (LINK_TAX, LINK_PERS, LINK_DED, SUMMA)
SELECT LINK_TAX, LINK_PERS, LINK_DED, SUM(SUMMA)
FROM 
	dbo.SDOC D
	INNER JOIN dbo.SDOC_DOT_VYCHET S ON S.LINK_UP = D.LINK
WHERE
	D.LINK_DEP = @DEP_LINK
	AND 
	YEAR(DATE_CALC)	= @Year AND MONTH(DATE_CALC) < @Month
GROUP BY
	LINK_TAX, LINK_PERS, LINK_DED

--====            

--      
SELECT 
	LINK_TAX = P.LINK, S.LINK_PERS, S.LINK_DED,
	SUMMA_M = 
	--CASE WHEN S.SUMMA_M > CASE WHEN ISNULL(VP.SUMMA,0) < V.PREDEL THEN (V.PREDEL - ISNULL(VP.SUMMA,0)) * (S.SUMMA_M / S.SUMMA_M) ELSE 0 END
	--	THEN CASE WHEN ISNULL(VP.SUMMA,0) < V.PREDEL THEN (V.PREDEL - ISNULL(VP.SUMMA,0)) * (S.SUMMA_M / S.SUMMA_M) ELSE 0 END
	--	ELSE S.SUMMA_M
	--END,
	(
		--  
		(CASE WHEN ISNULL(S.SUMMA,0) > ISNULL(V.PREDEL,0) THEN ISNULL(V.PREDEL,0) ELSE ISNULL(S.SUMMA,0) END) 
		-- 
		- ISNULL(VP.SUMMA,0)
	),		
	[PERCENT] = ISNULL(I.[PERCENT],DR.[PERCENT])
INTO #TMP_VYCH
FROM
	dbo.PAYS P
	INNER JOIN #RANGE DR -- 
							ON P.LINK = DR.LINK_PAYS
	INNER JOIN #SUMMA_U S --   
							ON 1=1
	INNER JOIN #VYCHET V --    
						ON V.LINK_DED = S.LINK_DED
	LEFT JOIN #VYCHET_PREV VP --       
						ON VP.LINK_PERS = S.LINK_PERS AND VP.LINK_DED = S.LINK_DED
	LEFT JOIN #INV I --    
					ON I.LINK = S.LINK_PERS
WHERE
	P.[OBJECT] = 3 AND P.WAY_CALC = 5
	AND S.SUMMA_M <> 0

--     
SELECT LINK_TAX, LINK_PERS, LINK_VKR, LINK_VKR2, LINK_EKR, SUMMA_M = SUM(SUMMA_M)
INTO #TMP_DOH FROM #SUMMA GROUP BY LINK_TAX, LINK_PERS, LINK_VKR, LINK_EKR, LINK_VKR2

--  
SELECT LINK_TAX, LINK_PERS, SUMMA_M = SUM(SUMMA_M)
INTO #TMP_DOH2 FROM #SUMMA GROUP BY LINK_TAX, LINK_PERS

--        
INSERT INTO dbo.SDOC_DOT_VYCHET (LINK_UP, LINK_TAX, LINK_PERS, LINK_VKR, LINK_VKR2, LINK_EKR, LINK_DED, SUMMA, [PERCENT])
SELECT 
	@LINK, D2.LINK_TAX, D2.LINK_PERS, D.LINK_VKR, D.LINK_VKR2, D.LINK_EKR, V.LINK_DED, ISNULL(V.SUMMA_M,0) * ISNULL(D.SUMMA_M,0) / D2.SUMMA_M, V.[PERCENT]
FROM
	#TMP_DOH2 D2 
	INNER JOIN #TMP_DOH D ON D.LINK_TAX = D2.LINK_TAX AND D.LINK_PERS = D2.LINK_PERS
	INNER JOIN #TMP_VYCH V ON D2.LINK_TAX = V.LINK_TAX AND D2.LINK_PERS = V.LINK_PERS
WHERE
	ISNULL(D2.SUMMA_M,0) <> 0	

SELECT 
	[PERCENT] = ISNULL(I.[PERCENT],DR.[PERCENT]),
	DR.LINK_PAYS,
	CODE_PAYS = P.CODE,
	NAME_PAYS = P.NAME,
	S.LINK_VKR,
	[NAME_VKR] = F.CODE,
	S.LINK_EKR,
	[NAME_EKR] = G.CODE,	
	SUMMA = SUM(S.SUMMA_M),
	SKIDKA = SUM(ISNULL(SK.SUMMA,0)),
	VYCHET = SUM(ISNULL(V.SUMMA,0)),
	S.LINK_VKR2,
	[NAME_VKR2] = F2.CODE	
FROM 
	#RANGE DR
	INNER JOIN dbo.PAYS P ON P.LINK = DR.LINK_PAYS
	INNER JOIN #TMP_DOH S ON S.LINK_TAX = DR.LINK_PAYS
	INNER JOIN dbo.SAL_SFIN F ON F.LINK = S.LINK_VKR
	INNER JOIN dbo.SAL_SFIN F2 ON F2.LINK = S.LINK_VKR2
	INNER JOIN dbo.KOSGU G ON G.LINK = S.LINK_EKR
	LEFT JOIN dbo.SDOC_DOT_SKIDKI SK ON  SK.LINK_UP = @LINK AND SK.LINK_TAX = DR.LINK_PAYS AND SK.LINK_PERS = S.LINK_PERS 
					AND SK.LINK_VKR = S.LINK_VKR AND SK.LINK_VKR2 = S.LINK_VKR2 and SK.LINK_EKR = S.LINK_EKR
	LEFT JOIN 
	(
		SELECT LINK_TAX, LINK_PERS, LINK_VKR, LINK_VKR2, LINK_EKR, SUMMA = SUM(SUMMA) FROM dbo.SDOC_DOT_VYCHET 
		WHERE LINK_UP = @LINK GROUP BY LINK_TAX, LINK_PERS, LINK_VKR, LINK_VKR2, LINK_EKR
	) V
	ON V.LINK_TAX = DR.LINK_PAYS AND V.LINK_PERS = S.LINK_PERS AND V.LINK_VKR = S.LINK_VKR AND V.LINK_VKR2 = S.LINK_VKR2 AND V.LINK_EKR = S.LINK_EKR
	LEFT JOIN #INV I ON I.LINK = S.LINK_PERS
GROUP BY
	ISNULL(I.[PERCENT],DR.[PERCENT]),
	DR.LINK_PAYS,
	P.CODE,
	P.NAME,
	S.LINK_VKR,
	F.CODE,
	S.LINK_EKR,
	G.CODE,
	S.LINK_VKR2,
	F2.CODE

DROP TABLE #SKIDKA
DROP TABLE #BASE
DROP TABLE #SUMMA
DROP TABLE #SUMMA2
DROP TABLE #SKIDKA_PREV
DROP TABLE #INV
DROP TABLE #TMP_VYCH
DROP TABLE #TMP_DOH
DROP TABLE #RANGE

GO


GRANT EXECUTE ON dbo.[SD_O_OTHER_FILL] TO PUBLIC

GO

GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SALARY_FILL_DED_ESN_VKR]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[SALARY_FILL_DED_ESN_VKR]

GO

CREATE PROCEDURE [dbo].SALARY_FILL_DED_ESN_VKR
--  
@RefPay int, 
@LinkVKR int,
@LINK_EKR INT, 
@linkPers int, 
@Month int, 
@Year int, 
@FlagMS  tinyint,
@FlagShow int = 0,
@DEP_LINK INT  = NULL,
@LinkVKR2 INT = NULL 
AS

SET NOCOUNT ON



IF @LinkVKR2 IS NULL
	SET @LinkVKR2 = @LinkVKR

DECLARE 
	@DATE1 datetime, 
	@linkFace int,
	@LINK_213EKR INT,
	@LINK_211EKR INT,
	@TARIF TINYINT,
	@SHOW_212 TINYINT,
	@LINK_EKR_ADD INT
		  
SET @TARIF = ISNULL((SELECT TOP 1 ENVD FROM dbo.SAL_SFIN WHERE LINK = @LinkVKR),0) + 1	
		  
SET @LINK_211EKR = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '211')
SET @LINK_EKR_ADD = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '212')
SET @LINK_213EKR = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '213')
SET @FlagMS = 1
SET @SHOW_212 = dbo.SA_GET_OPTION_BY_CODE('ESN_OPTIONS_3')

IF @SHOW_212 = 1 OR @LINK_EKR <> @LINK_211EKR
	SET @LINK_EKR_ADD = @LINK_EKR
	
DECLARE @ESN_OPTIONS_7 INT -- .     
--         .          . 
--   ,  .   .
SET @ESN_OPTIONS_7 = dbo.SA_GET_OPTION_BY_CODE('ESN_OPTIONS_7')

DECLARE @ESN_OPTIONS_8 INT -- .   
--         .     .
SET @ESN_OPTIONS_8 = dbo.SA_GET_OPTION_BY_CODE('ESN_OPTIONS_8')

DECLARE @DATE_BEG DATETIME
SET @DATE_BEG = dbo.convertDMY2Date(1,@Month,@Year)
SET @DATE1 = dbo.DateEndOfMonth(@DATE_BEG)

DECLARE @DATE_YEAR_BEG DATETIME
SET @DATE_YEAR_BEG = dbo.convertDMY2Date(1,1,@Year)

SELECT @linkFace = @linkPers 

DECLARE @T1 TABLE
([NUM]			[int],
 [SUMMA]		[numeric](19,2),
 [SUMMA_VKR]		[numeric](19,2),
 [SUMMA_M]		[numeric](19,2),
 [SUMMA_M_VKR]		[numeric](19,2))


IF @DEP_LINK IS NULL
	exec dbo.xd_whats_zb @DEP_LINK output

declare @linkEmpl int,  @Pred_Mesto_Rab numeric(15,2), 	  @FlagD int

SET @linkEmpl = 
	(SELECT TOP 1 IM.EMPL_LINK
	FROM
		DBO.EMPL E with (nolock)
		LEFT JOIN DBO.ITEM_MOVE IM with (nolock) ON IM.EMPL_LINK = E.LINK AND IM.ACTIVE = 1 AND IM.NEW_FACE=1 AND IM.[STATUS] IN (1,3) AND IM.DATE_BEGIN <= @DATE1
		LEFT JOIN DBO.ITEM_DIS_FACE IDF with (nolock) ON IDF.EMPL_LINK = E.LINK AND IDF.ACTIVE=1 AND COALESCE(IDF.DIS_DATE,'20990101') >= dbo.DateBeginOfMonth(@DATE1)
	WHERE
		E.DEP_LINK = @DEP_LINK
		AND
		E.PERS_LINK = @linkPers
	ORDER BY
		DATE_BEGIN DESC	
	)	

---------------------------------------------------
DECLARE @item_move TABLE (LINK INT, EMPL_LINK INT, STAFF_LINK INT, DATE_BEGIN DATETIME, DATE_END DATETIME, NUM_STAKE NUMERIC(5,3), active TINYINT, NEW_FACE TINYINT, [STATUS] TINYINT)
INSERT INTO @item_move (LINK, EMPL_LINK, STAFF_LINK, DATE_BEGIN, DATE_END, NUM_STAKE, active, NEW_FACE, [STATUS])
Select 
	P1.LINK, P1.EMPL_LINK, P1.STAFF_LINK, P1.DATE_BEGIN, P1.DATE_END, P1.NUM_STAKE, P1.active, P1.NEW_FACE, P1.[STATUS]
from 
	dbo.empl e INNER JOIN dbo.item_move P1 ON P1.EMPL_LINK = e.link
WHERE
	E.DEP_LINK = @DEP_LINK AND E.PERS_LINK	= @linkPers
---------------------------------------------------

--       
DECLARE @NUM_STAKE TABLE (LINK_EMPL INT, NUM_STAKE NUMERIC(18,4), DATE_BEG DATETIME, DATE_END DATETIME)
INSERT INTO @NUM_STAKE (LINK_EMPL, NUM_STAKE, DATE_BEG, DATE_END)
SELECT DISTINCT
	EMPL_LINK, NUM_STAKE, DATE_BEGIN, DATE_END 
FROM @item_move
WHERE active = 1 AND NEW_FACE <> 3 AND @DATE1 BETWEEN DATE_BEGIN AND DATE_END

if @FlagShow = 1 
	select ':  '+ LTRIM(RTRIM(P.FM)) + ' ' + SUBSTRING(LTRIM(RTRIM(P.IM)),1,1) + '.' + SUBSTRING(LTRIM(RTRIM(P.OT)),1,1)
		+  ',  ' + convert(varchar(2),@Month)+ ',  ' +convert(varchar(4),@Year) as [ ],
		[] = (select rtrim(name) from pays where link =@RefPay)  FROM dbo.PERSON P where link = @linkFace


DECLARE @NASTR TABLE
([LINK_MINROT] 	[int],
 [REF_PAY]			[int],
 [CODE]				[varchar](5),
 [NAME]				[varchar](254),
 [PREDEL]			[numeric](19, 2))

INSERT INTO @NASTR([LINK_MINROT],[REF_PAY],[CODE],[NAME],[PREDEL])
SELECT [LINK_MINROT],[REF_PAY],[CODE],[NAME],[PREDEL] FROM dbo.Salary_deduct_esn(@DATE1)

SELECT @Pred_Mesto_Rab = 0, @FlagD = 0

IF dbo.SA_GET_OPTION_BY_CODE('ESN_OPTIONS_6 ') = 1
BEGIN
	IF YEAR(dbo.kd_DateBeginWork(@linkEmpl,null)) = @Year
	BEGIN
		SET @Pred_Mesto_Rab = (SELECT ISNULL(SUM(SUMMA_DED),0) FROM dbo.SD_EMPL_PREV_DED WHERE LINK_EMPL = @linkEmpl and LINK_DED in (select REF_PAY from @NASTR))
		IF @Pred_Mesto_Rab IS null or @Pred_Mesto_Rab < 0
			SET @Pred_Mesto_Rab = 0
		SET @FlagD = 1
		
		IF  @FlagShow = 1 
			SELECT ' : '+ rtrim(isnull(convert(varchar(100),(select sum(summa_TYP_INCOMS) from dbo.SD_EMPL_PREV_DOHOD where link_empl =@linkEmpl)),'0')) + ' , : '+
			 rtrim( isnull( convert(varchar(100),(select sum(summa_ded) from dbo.SD_EMPL_PREV_DED where link_empl =@linkEmpl and LINK_DED in (select REF_PAY from @NASTR) )),'0'))  as '    '
	END
END	

---       ,     ---
DECLARE @SUM_DGH numeric(15,2)
SET @SUM_DGH = 
	ISNULL(
	(
	SELECT SUM(GT.SUMMA_BASE)
	FROM dbo.DOCUMENTS_DGH G INNER JOIN dbo.DOCUMENTS_DGH_T3 GT ON G.LINK = GT.LINK
	WHERE FLAG_JC = 1
			AND YEAR(G.[DATE]) = @Year
			AND MONTH(G.[DATE]) <= @Month
			AND G.LINK_DEP = @DEP_LINK
			AND GT.LINK_PAY = @RefPay
			AND GT.PERS_LINK = @linkFace
	),0)

IF @SUM_DGH <> 0 AND @FlagShow = 1 
	SELECT ' : '+ rtrim(isnull(convert(varchar(100),@SUM_DGH),'0')) as '   '


CREATE TABLE #PERIODY (LINK_EMPL INT, LINK_PERSON INT, TAB VARCHAR(10), NUM_STAKE NUMERIC(18,4), POSTNAME VARCHAR(50), st_date1 datetime, st_date2 datetime, im_date1 datetime, im_date2 datetime, [COD_SPO_USL_TRUD] int)

---------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT * FROM dbo.PAYS WHERE OBJECT = 3 AND WAY_CALC IN (10,11) AND LINK = @RefPay)
BEGIN

	--sa_item_move
	--	
	DECLARE @sa_item_move TABLE (EMPL_LINK INT, STAFF_LINK INT, DATE_BEGIN DATETIME, DATE_END3 DATETIME, NUM_STAKE NUMERIC(5,3), [STATUS] TINYINT )

	INSERT INTO @sa_item_move (EMPL_LINK, STAFF_LINK, DATE_BEGIN, DATE_END3, NUM_STAKE, [STATUS])
	Select 
		P1.EMPL_LINK, P1.STAFF_LINK, P1.DATE_BEGIN, date_end3 = min(P2.date_begin) - 1, P1.NUM_STAKE, P1.[STATUS]
	from 
		dbo.empl e
		INNER JOIN @item_move P1 ON P1.EMPL_LINK = e.link
		INNER JOIN @item_move P2 on P1.EMPL_LINK = P2.EMPL_LINK
	where
		E.PERS_LINK	= @linkPers 
		AND P1.active = 1 AND P2.active = 1 AND P1.NEW_FACE <> 3 AND P2.NEW_FACE <> 3
		AND P1.[date_begin] < P2.[date_begin] 
	group by 
		P1.EMPL_LINK, P1.STAFF_LINK, P1.DATE_BEGIN, P1.NUM_STAKE, P1.[STATUS]

	INSERT INTO @sa_item_move (EMPL_LINK, STAFF_LINK, DATE_BEGIN, DATE_END3, NUM_STAKE, [STATUS])
	Select 
		P3.EMPL_LINK, P3.STAFF_LINK, P3.DATE_BEGIN, date_end3 = '99991231', P3.NUM_STAKE, P3.[STATUS]
	from
		dbo.empl e 
		INNER JOIN @item_move P3 ON P3.EMPL_LINK = e.link
	where
		E.PERS_LINK	= @linkPers  
		AND
		P3.active = 1 AND P3.NEW_FACE <> 3
		AND
		NOT EXISTS (
					Select *
					from 
						@item_move P1 inner join @item_move P2 on P1.EMPL_LINK = P2.EMPL_LINK
					where
						P1.LINK = P3.link
						AND P1.active = 1 and P2.active = 1 AND P1.NEW_FACE <> 3 AND P2.NEW_FACE <> 3
						and P1.[date_begin] < P2.[date_begin] 
					)
	-----------------------------------------------------------------------------------------------------

	CREATE TABLE #ADD_TYPE (
		[type] INT IDENTITY(1,1),
		[TERR_USL_TRUD] int NULL ,
		[TERR_RK] numeric(3, 2) NULL ,
		[OSOB_USL_TRUD] int NULL ,
		[COD_POS_SPISOK] int NULL ,
		[COD_POS_SPISOK2] int NULL ,
		[USL_DOSROCH_PENS] int NULL ,
		[STAVKA_PED_MED] numeric(3, 2) NULL,
		[COD_SPO_USL_TRUD] int NULL
	)

	INSERT INTO #ADD_TYPE 
	SELECT DISTINCT ISNULL(TERR_USL_TRUD,0), ISNULL(TERR_RK,0), ISNULL(OSOB_USL_TRUD,0), ISNULL(COD_POS_SPISOK,0), ISNULL(COD_POS_SPISOK2,0), ISNULL(USL_DOSROCH_PENS,0), ISNULL(STAVKA_PED_MED,0), ISNULL([COD_SPO_USL_TRUD],0)
	FROM dbo.staff
	WHERE ISNULL(COD_POS_SPISOK,0) <> 0 OR ISNULL(COD_POS_SPISOK2,0) <> 0

	INSERT INTO 
		#PERIODY (LINK_EMPL, LINK_PERSON, TAB, NUM_STAKE, POSTNAME, st_date1, st_date2, im_date1, im_date2, [COD_SPO_USL_TRUD])
	SELECT DISTINCT
		E.LINK,
		E.PERS_LINK,
		TAB,
		IM.NUM_STAKE,
		LEFT(PT.NAME,50),
		st_date1 = dbo.DateBeginOfMonth((case when st.DATE_BEGIN >= @DATE_YEAR_BEG then st.DATE_BEGIN else @DATE_YEAR_BEG end)),
		st_date2 = dbo.DateEndOfMonth((case when coalesce(st.DATE_END,@DATE1) <= @DATE1 then coalesce(st.DATE_END,@DATE1) else @DATE1 end)	),
		im_date1 = dbo.DateBeginOfMonth((case when im.DATE_BEGIN >= @DATE_YEAR_BEG then im.DATE_BEGIN else @DATE_YEAR_BEG end)),
		im_date2 = dbo.DateEndOfMonth( 
							CASE WHEN COALESCE(U.DIS_DATE,'20990101') <= (case when ISNULL(ISNULL(U.DIS_DATE,im.DATE_END3),@DATE1) <= @DATE1 then ISNULL(ISNULL(U.DIS_DATE,im.DATE_END3),@DATE1) else @DATE1 end)
								THEN COALESCE(U.DIS_DATE,'20990101')
								ELSE (case when ISNULL(ISNULL(U.DIS_DATE,im.DATE_END3),@DATE1) <= @DATE1 then ISNULL(ISNULL(U.DIS_DATE,im.DATE_END3),@DATE1) else @DATE1 end)
							END	),
		T.[COD_SPO_USL_TRUD]							
	FROM 
		dbo.empl e
		INNER JOIN @sa_item_move im ON im.EMPL_LINK = e.link
		inner join dbo.staff_head sh on sh.link = STAFF_LINK
		inner join dbo.staff st on st.link_up = sh.link
		INNER JOIN dbo.POST PT ON PT.LINK = st.post_link
		INNER join #ADD_TYPE T on ISNULL(st.TERR_USL_TRUD,0) = ISNULL(T.TERR_USL_TRUD,0) 
								AND ISNULL(st.TERR_RK,0) = ISNULL(T.TERR_RK,0) 
								AND ISNULL(st.OSOB_USL_TRUD,0) = ISNULL(T.OSOB_USL_TRUD,0) 
								AND ISNULL(st.COD_POS_SPISOK,0) = ISNULL(T.COD_POS_SPISOK,0) 
								AND ISNULL(st.COD_POS_SPISOK2,0) = ISNULL(T.COD_POS_SPISOK2,0) 
								AND ISNULL(st.USL_DOSROCH_PENS,0) = ISNULL(T.USL_DOSROCH_PENS,0) 
								AND ISNULL(st.STAVKA_PED_MED,0) = ISNULL(T.STAVKA_PED_MED,0)
								AND ISNULL(st.COD_SPO_USL_TRUD,0) = ISNULL(T.COD_SPO_USL_TRUD,0)
		LEFT JOIN dbo.ITEM_DIS_FACE U on E.link = U.empl_link AND U.ACTIVE=1	
	where
		E.PERS_LINK	= @linkPers
		and  
		im.DATE_BEGIN <= @DATE1 and im.DATE_END3 >= @DATE_YEAR_BEG
		AND
		IM.[STATUS] <> 2 --      (  )
		AND
		st.DATE_BEGIN <= @DATE1 and st.DATE_END >= @DATE_YEAR_BEG
		AND
		T.[TYPE] IS NOT NULL
		AND
		(
			ISNULL(T.[COD_POS_SPISOK],0) <> 0 AND EXISTS (SELECT * FROM dbo.PAYS WHERE OBJECT = 3 AND WAY_CALC = 10 AND LINK = @RefPay)
			OR
			ISNULL(T.[COD_POS_SPISOK2],0) <> 0 AND EXISTS (SELECT * FROM dbo.PAYS WHERE OBJECT = 3 AND WAY_CALC = 11 AND LINK = @RefPay)	
		)	

	if @FlagShow = 1 
		SELECT DISTINCT TAB AS [_],  LEFT(dbo.ku_GetEmplSubdivName(LINK_EMPL,@DATE1),50) AS [], POSTNAME AS [], CONVERT(VARCHAR(10), ST_DATE1, 104) AS '____', CONVERT(VARCHAR(10),ST_DATE2,104) AS '____' FROM #PERIODY
			
	if @FlagShow = 1 
		SELECT DISTINCT TAB AS [_],  NUM_STAKE AS [- ], LEFT(dbo.ku_GetEmplSubdivName(LINK_EMPL,@DATE1),50) AS [], POSTNAME AS [], CONVERT(VARCHAR(10), IM_DATE1, 104) AS '____', CONVERT(VARCHAR(10),IM_DATE2,104) AS '____', CASE WHEN NUM_STAKE < 1 THEN '.   , ..   ' ELSE '' END AS []
		FROM #PERIODY
	
	INSERT INTO @T1 ([NUM],[SUMMA],[SUMMA_VKR],[SUMMA_M],[SUMMA_M_VKR])
	SELECT M.NUM,SUM(SJ.SUMMA) AS SUMMA, 			
			 [SUMMA_VKR]	= SUM(CASE WHEN SJ.LINK_VKR = @LinkVKR2 AND SJ.LINK_EKR IN (@LINK_EKR,@LINK_EKR_ADD) THEN SJ.SUMMA ELSE 0 END),
			 [SUMMA_M] 		= SUM(CASE WHEN MONTH(SJ.PERIOD_BEGIN) = M.NUM THEN SJ.SUMMA ELSE 0 END),
			 [SUMMA_M_VKR] = SUM(CASE WHEN (MONTH(SJ.PERIOD_BEGIN) = M.NUM) 
								AND (SJ.LINK_VKR = @LinkVKR2 AND SJ.LINK_EKR  IN (@LINK_EKR,@LINK_EKR_ADD)) THEN SJ.SUMMA ELSE 0 END)
	FROM 
		dbo.MONTHS M
		INNER JOIN dbo.EMPL E ON 1=1
		INNER JOIN dbo.CALCULATE_JURNAL SJ ON SJ.LINK_EMPL = E.LINK
		INNER JOIN dbo.TAX_REF TR ON TR.LINK_PAYS =  SJ.LINK_PAYS
	WHERE 
		E.PERS_LINK = @linkFace
		AND (M.NUM <= @Month) 
		AND (MONTH(SJ.PERIOD_BEGIN) <= M.NUM) 
		AND (YEAR(SJ.PERIOD_BEGIN) = @Year)
		AND TR.LINK_TAX = @RefPay 
		AND EXISTS (SELECT * FROM #PERIODY P WHERE 
												(@ESN_OPTIONS_7 = 0 OR @ESN_OPTIONS_7 = 1 AND P.NUM_STAKE >=1)
												AND 
												(
													@ESN_OPTIONS_8 = 0 AND P.LINK_EMPL = SJ.LINK_EMPL 
													OR
													@ESN_OPTIONS_8 = 1 AND P.LINK_PERSON = E.PERS_LINK
												)	
												AND SJ.PERIOD_BEGIN <= P.ST_DATE2 
												AND SJ.PERIOD_END >= P.ST_DATE1 
												AND SJ.PERIOD_BEGIN <= P.IM_DATE2 
												AND SJ.PERIOD_END >= P.IM_DATE1)
	GROUP BY  M.NUM	

	
END
---------------------------------------------------------------------------------------------------------------
ELSE
	INSERT INTO @T1 ([NUM],[SUMMA],[SUMMA_VKR],[SUMMA_M],[SUMMA_M_VKR])
	SELECT M.NUM,SUM(SJ.SUMMA) AS SUMMA, 			
			 [SUMMA_VKR]	= SUM(CASE WHEN SJ.LINK_VKR = @LinkVKR2 AND SJ.LINK_EKR IN (@LINK_EKR,@LINK_EKR_ADD) THEN SJ.SUMMA ELSE 0 END),
			 [SUMMA_M] 		= SUM(CASE WHEN MONTH(SJ.PERIOD_BEGIN) = M.NUM THEN SJ.SUMMA ELSE 0 END),
			 [SUMMA_M_VKR] = SUM(CASE WHEN (MONTH(SJ.PERIOD_BEGIN) = M.NUM) AND (SJ.LINK_VKR = @LinkVKR2 AND SJ.LINK_EKR  IN (@LINK_EKR,@LINK_EKR_ADD)) THEN SJ.SUMMA ELSE 0 END)
	FROM 
		dbo.MONTHS M
		INNER JOIN dbo.CALCULATE_JURNAL SJ ON 1=1 
		INNER JOIN dbo.TAX_REF TR ON TR.LINK_PAYS =  SJ.LINK_PAYS
		INNER JOIN dbo.EMPL E ON SJ.LINK_EMPL = E.LINK
	WHERE 
		(TR.LINK_TAX = @RefPay) 
		AND (E.PERS_LINK = @linkFace) 
		AND (MONTH(SJ.PERIOD_BEGIN) <= M.NUM) AND (M.NUM <= @Month) AND (YEAR(SJ.PERIOD_BEGIN)=@Year)
		AND sj.LINK_DEP = @DEP_LINK
	GROUP BY  M.NUM

if @FlagShow = 1 
	SELECT [num] as [], [summa] as [   ],summa_vkr as [     /], summa_m as [  ], 
	summa_m_vkr as [    /]  FROM @T1

-- ,        ,     
IF NOT EXISTS(SELECT * FROM @T1)
	INSERT INTO @T1 ([NUM],[SUMMA],[SUMMA_VKR],[SUMMA_M],[SUMMA_M_VKR])
	VALUES(@Month, 0, 0, 0, 0)

DECLARE @Temp1_1 TABLE
([NUM]			[int],
 [LINK_PAYS]	[int],
 [MP]				[numeric](19,2),
 [MP_M]			[numeric](19,2),
 [MP_M_VKR]		[numeric](19,2))

--------------------------------------------------
CREATE TABLE #DICTIONARY_TYP_INCOMS (LINK INT)
INSERT INTO #DICTIONARY_TYP_INCOMS (LINK)
SELECT LINK FROM dbo.DICTIONARY_TYP_INCOMS WHERE EXISTS (SELECT * FROM @NASTR WHERE REF_PAY = REF_DEDUCT)
CREATE INDEX #DICTIONARY_TYP_INCOMS_IDX1 ON #DICTIONARY_TYP_INCOMS (LINK)

-------------------------------------------------
CREATE TABLE #PAYS (LINK INT)
INSERT INTO #PAYS (LINK)
SELECT P.LINK FROM dbo.PAYS P INNER JOIN #DICTIONARY_TYP_INCOMS I ON I.LINK = P.LINK_INC
CREATE INDEX #PAYS_IDX1 ON #PAYS (LINK)


--------------------------------------------------------------------------------------------------
IF EXISTS (SELECT * FROM dbo.PAYS WHERE OBJECT = 3 AND WAY_CALC IN (10,11) AND LINK = @RefPay)
	
	INSERT INTO @Temp1_1 ([NUM],[LINK_PAYS],[MP],[MP_M],[MP_M_VKR])
	SELECT M.NUM,
			 [LINK_PAYS]= (SELECT LINK_INC  from pays where link = sj.LINK_PAYS),
			 [MP] 		= SUM(CASE WHEN month(SJ.PERIOD_BEGIN)<=m.num then SJ.summa else 0 end), 
			 [MP_M] 		= SUM(CASE WHEN month(SJ.PERIOD_BEGIN)=m.num then (CASE WHEN month(SJ.PERIOD_BEGIN)<=m.num then SJ.summa else 0 end) else 0 end),
			 [MP_M_VKR] = SUM(CASE WHEN ( month(SJ.PERIOD_BEGIN)=m.num)AND(sj.link_vkr = @LinkVKR2 AND SJ.LINK_EKR  IN (@LINK_EKR,@LINK_EKR_ADD)) 
								THEN (CASE WHEN month(SJ.PERIOD_BEGIN)<=m.num then SJ.summa else 0 end) else 0 end)
	FROM 
		dbo.MONTHS M 
		INNER JOIN dbo.S_J_C_Short SJ ON 1=1
		INNER JOIN #PAYS P ON P.LINK = SJ.LINK_PAYS
		INNER JOIN dbo.TAX_REF TR ON TR.LINK_PAYS =  SJ.LINK_PAYS
	WHERE 
		TR.LINK_TAX = @RefPay 
		AND (SJ.LINK_FACE = @linkFace)
		AND YEAR(SJ.PERIOD_BEGIN)=@Year AND M.NUM <= @Month 
		AND sj.LINK_DEP = @DEP_LINK
		AND EXISTS (SELECT * FROM #PERIODY P WHERE 
									(
										@ESN_OPTIONS_8 = 0 AND P.LINK_EMPL = SJ.LINK_EMPL
										OR
										@ESN_OPTIONS_8 = 1 AND P.LINK_PERSON = SJ.LINK_FACE
									)									
									AND SJ.PERIOD_BEGIN <= P.ST_DATE2 AND SJ.PERIOD_END >= P.ST_DATE1)		
		AND EXISTS (SELECT * FROM #PERIODY P WHERE 
									(
										@ESN_OPTIONS_8 = 0 AND P.LINK_EMPL = SJ.LINK_EMPL
										OR
										@ESN_OPTIONS_8 = 1 AND P.LINK_PERSON = SJ.LINK_FACE
									)	
									AND (@ESN_OPTIONS_7 = 0 OR @ESN_OPTIONS_7 = 1 AND P.NUM_STAKE >=1)
									AND SJ.PERIOD_BEGIN <= P.IM_DATE2 AND SJ.PERIOD_END >= P.IM_DATE1)		
	GROUP BY 
		M.NUM,SJ.LINK_PAYS
ELSE
	INSERT INTO @Temp1_1 ([NUM],[LINK_PAYS],[MP],[MP_M],[MP_M_VKR])
	SELECT M.NUM,
			 [LINK_PAYS]= (SELECT LINK_INC  from pays where link = sj.LINK_PAYS),
			 [MP] 		= SUM(CASE WHEN month(SJ.PERIOD_BEGIN)<=m.num then SJ.summa else 0 end), 
			 [MP_M] 		= SUM(CASE WHEN month(SJ.PERIOD_BEGIN)=m.num then (CASE WHEN month(SJ.PERIOD_BEGIN)<=m.num then SJ.summa else 0 end) else 0 end),
			 [MP_M_VKR] = SUM(CASE WHEN ( month(SJ.PERIOD_BEGIN)=m.num)AND(sj.link_vkr = @LinkVKR2 AND SJ.LINK_EKR  IN (@LINK_EKR,@LINK_EKR_ADD)) 
								THEN (CASE WHEN month(SJ.PERIOD_BEGIN)<=m.num then SJ.summa else 0 end) else 0 end)
	FROM 
		dbo.MONTHS M 
		INNER JOIN dbo.S_J_C_Short SJ ON 1=1
		INNER JOIN #PAYS P ON P.LINK = SJ.LINK_PAYS
		INNER JOIN dbo.TAX_REF TR ON TR.LINK_PAYS =  SJ.LINK_PAYS
	WHERE 
		TR.LINK_TAX = @RefPay 
		AND (SJ.LINK_FACE = @linkFace)
		AND YEAR(SJ.PERIOD_BEGIN)=@Year AND M.NUM <= @Month 
		AND sj.LINK_DEP = @DEP_LINK
	GROUP BY 
		M.NUM,SJ.LINK_PAYS
	

/*if @FlagShow = 1  
	select *  from @Temp1_1*/

DECLARE @Temp1 TABLE
([NUM]			[int],
 [LINK_PAYS]	[int],
 [PREDEL]		[numeric](19,2),
 [MP]				[numeric](19,2),
 [MP_M]			[numeric](19,2),
 [MP_M_VKR]		[numeric](19,2))

INSERT INTO @Temp1 ([NUM],[LINK_PAYS],[PREDEL],[MP],[MP_M],[MP_M_VKR])
SELECT NUM,LINK_PAYS,
		[PREDEL] =  ISNULL((SELECT TOP 1 PREDEL FROM @NASTR 
								WHERE REF_PAY = (SELECT TOP 1 REF_DEDUCT FROM dbo.DICTIONARY_TYP_INCOMS WHERE LINK = LINK_PAYS)),0),
		SUM(MP) AS MP,
		SUM(MP_M) AS MP_M, 
		SUM(MP_M_VKR) AS MP_M_VKR
FROM @Temp1_1
GROUP BY NUM,LINK_PAYS

DECLARE @Temp2 TABLE
([NUM]			[int],
 [LINK_PAYS]	[int],
 [PREDEL]		[numeric](19,2),
 [MP]				[numeric](19,2),
 [MP_M]			[numeric](19,2),
 [MP_M_VKR]		[numeric](19,2),
 [SALDO]			[numeric](19,2),
 [KOEF]			[numeric](19,10))

---


INSERT INTO @Temp2 ([NUM],[LINK_PAYS],[PREDEL],[MP],[MP_M],[MP_M_VKR],[SALDO],[KOEF]) 
SELECT T1.[NUM],T1.[LINK_PAYS],T1.[PREDEL],T1.[MP],T1.[MP_M],T1.[MP_M_VKR],
		 [SALDO] = (CASE WHEN @Pred_Mesto_Rab + ISNULL((SELECT SUM(MP_M) FROM @Temp1 T2 WHERE T2.NUM <= T1.NUM AND T2.LINK_PAYS = T1.LINK_PAYS),0) > PREDEL
				THEN PREDEL
				ELSE @Pred_Mesto_Rab + ISNULL((SELECT SUM(MP_M) FROM @Temp1 T2 WHERE T2.NUM <= T1.NUM AND T2.LINK_PAYS = T1.LINK_PAYS),0)
				END)
				- (CASE WHEN @Pred_Mesto_Rab + ISNULL((SELECT SUM(MP_M) FROM @Temp1 T2 WHERE T2.NUM < T1.NUM AND T2.LINK_PAYS = T1.LINK_PAYS),0) > PREDEL
				THEN PREDEL
				ELSE @Pred_Mesto_Rab + ISNULL((SELECT SUM(MP_M) FROM @Temp1 T2 WHERE T2.NUM < T1.NUM AND T2.LINK_PAYS = T1.LINK_PAYS),0)
				END),
		 [KOEF] 	= (CASE WHEN (SELECT SUM(MP_M) FROM @Temp1 T3 WHERE T3.NUM = T1.NUM AND T3.LINK_PAYS = T1.LINK_PAYS) = 0 
						THEN 0 ELSE (CASE WHEN (SELECT SUM(MP_M) 
				                         FROM @Temp1 T3 WHERE T3.NUM = T1.NUM AND T3.LINK_PAYS = T1.LINK_PAYS)= 0 
										  THEN 0 ELSE 										
											MP_M_VKR/(SELECT SUM(MP_M) 
                    				     FROM @Temp1 T3 WHERE T3.NUM = T1.NUM AND T3.LINK_PAYS = T1.LINK_PAYS) END) END)
FROM @Temp1 T1

declare @predel numeric(18,2)
Set @predel = COALESCE((SELECT TOP 1 PREDEL FROM @Temp1),0)


DECLARE @Temp3 TABLE
([NUM]			[int],
 [LINK_PAYS]	[int],
 [SUMMA]			[numeric](19,2),
 [SUMMA_ALL]	[numeric](19,2),
 [SUMMA_M]		[numeric](19,2),
 [SUMMA_M_VKR]		[numeric](19,2)
)

INSERT INTO @Temp3 ([NUM],[LINK_PAYS],[SUMMA],[SUMMA_ALL],[SUMMA_M], SUMMA_M_VKR)
SELECT  T.[NUM], T.[LINK_PAYS],
		  [SUMMA] 	= dbo.IS_MIN((SELECT SUM(T3.SALDO * KOEF) FROM @Temp2 T3 WHERE  T3.NUM <= T.NUM AND T3.LINK_PAYS = T.LINK_PAYS),T.PREDEL), 
		  [SUMMA_ALL] 	= dbo.IS_MIN((SELECT SUM(T3.SALDO) FROM @Temp2 T3 WHERE  T3.NUM <= T.NUM AND T3.LINK_PAYS = T.LINK_PAYS),T.PREDEL),
		  [SUMMA_M] 	= CASE WHEN ABS(SUM(MP_M)) < ABS(T.SALDO) THEN ABS(T.SALDO) ELSE T.SALDO END,
		SUMMA_M_VKR 	= CASE WHEN ABS(SUM(MP_M)) < ABS(T.SALDO) THEN ABS(T.SALDO) ELSE T.SALDO END * KOEF
FROM @Temp2 T --WHERE SALDO > 0
GROUP BY T.NUM,T.PREDEL,T.SALDO,T.LINK_PAYS, KOEF 
ORDER BY T.NUM

if @FlagShow = 1  
	select num as [], LINK_PAYS as [], summa as [  /], summa_all as [   ], summa_m as [  ]  from @Temp3


DECLARE @PREDEL_INV [numeric](15, 2)
SET @PREDEL_INV = ISNULL((SELECT TOP 1 PREDEL FROM dbo.DICTIONARY_MROT_TABLE3 DMT 
									WHERE LINK_MINROT = (SELECT TOP 1 LINK FROM dbo.DICTIONARY_MROT 
									WHERE PERIOD <=@DATE1 ORDER BY PERIOD DESC) AND (REF_PAY = @RefPay)),0)

DECLARE @T2_1 TABLE
([NUM]			[int],
 [SUMMA]			[numeric](19, 2),
 [SUMMA_VKR]	[numeric](19, 2),
 [SUMMA_M]		[numeric](19, 2),
 [SUMMA_M_VKR]	[numeric](19, 2),
 [MP]				[numeric](19, 2),
 [MP_VKR]		[numeric](19, 2),
 [MP_M]			[numeric](19, 2),
 [MP_M_VKR]		[numeric](19, 2),
 [STATUS]		[int],
 [INV]			[numeric](19, 2))


INSERT INTO @T2_1 ([NUM],[SUMMA],[SUMMA_VKR],[SUMMA_M],[SUMMA_M_VKR],[MP],[MP_VKR],[MP_M],[MP_M_VKR],[STATUS],[INV])
SELECT T1.[NUM],T1.[SUMMA],T1.[SUMMA_VKR],T1.[SUMMA_M],T1.[SUMMA_M_VKR],
--		 [MP] 		= ISNULL((SELECT SUM(SUMMA) FROM @Temp3 T WHERE T.NUM <= T1.NUM),0),  
		 [MP] 		= ISNULL((SELECT SUM(SUMMA_ALL) FROM @Temp3 T WHERE T.NUM = T1.NUM),0),  
		 [MP_VKR]	= ISNULL((SELECT SUM(SUMMA) FROM @Temp3 T WHERE T.NUM = T1.NUM),0),  
		 [MP_M] 	= ISNULL((SELECT SUM(SUMMA_M) FROM @Temp3 T WHERE T.NUM = T1.NUM),0),  
		 [MP_M_VKR] = ISNULL((SELECT SUM(SUMMA_M_VKR) FROM @Temp3 T WHERE T.NUM = T1.NUM),0),  
--		 [MP_M_VKR] = ISNULL((SELECT SUM(SUMMA) FROM @Temp3 T WHERE T.NUM = T1.NUM),0),  
		 [STATUS] 	= dbo.is_invalid(@linkFace,dbo.DateEndOfMonth(dbo.ConvertDMY2Date(1,T1.NUM,@Year))), 
		 [INV] 		= cast(0 as numeric(15,2))
FROM @T1 T1 
GROUP BY T1.NUM,T1.SUMMA,T1.SUMMA_VKR,T1.SUMMA_M,T1.SUMMA_M_VKR
ORDER BY T1.NUM


DECLARE @summa_m 	[numeric](15, 2), 
		  @mp_m 		[numeric](15, 2),
		  @num 		[int], 
		  @Flag 		[bit], 
		  @itog 		[numeric](15, 2)

SET @itog = 0
DECLARE TMP_CUR CURSOR
FOR SELECT SUMMA_M, MP_M,NUM FROM @T2_1 WHERE STATUS = 2
OPEN TMP_CUR
FETCH TMP_CUR INTO @summa_m,@mp_m,@num
WHILE (@@FETCH_STATUS  = 0) AND (@PREDEL_INV - @itog) > 0 BEGIN
	IF @PREDEL_INV < (@itog+ @summa_m - @mp_m)
		UPDATE @T2_1 SET INV =(@PREDEL_INV-@itog) WHERE NUM = @num
	ELSE
		UPDATE @T2_1 SET INV =(@summa_m - @mp_m) WHERE NUM = @num
	
	SET @itog = @itog + @summa_m - @mp_m
	FETCH TMP_CUR INTO @summa_m,@mp_m,@num
END
CLOSE TMP_CUR
DEALLOCATE TMP_CUR

--      
---  
select 
	TA.LINK_DED, MON = MONTH(CJ.PERIOD_BEGIN),
	SUMMA_G = CAST(0 AS NUMERIC(18,2)),
	SUMMA_M = SUM(SUMMA),
	LIMIT = ISNULL((SELECT TOP 1 PREDEL FROM @NASTR WHERE REF_PAY = TA.LINK_DED),0)
INTO #DED_U
from 
	dbo.EMPL E inner join dbo.calculate_jurnal cj on e.link = cj.link_empl
	inner join dbo.TAX2_APP TA on TA.LINK_UP = CJ.LINK_PAYS
where 
	cj.LINK_DEP = @DEP_LINK
	AND
	year(period_begin) = @Year
	and
	E.PERS_LINK = @linkPers	
	and 
	MONTH(cj.PERIOD_BEGIN) <= @Month
	and
	ISNULL(TA.LINK_DED,0) > 0
GROUP BY 
	TA.LINK_DED, MONTH(CJ.PERIOD_BEGIN)


UPDATE A
SET SUMMA_G = (SELECT SUM(SUMMA_M) FROM #DED_U B WHERE B.MON <= A.MON )
FROM #DED_U A

UPDATE #DED_U
SET 
	SUMMA_G = CASE WHEN ISNULL(SUMMA_G,0) < ISNULL(LIMIT,0) THEN ISNULL(SUMMA_G,0) ELSE ISNULL(LIMIT,0) END,
	SUMMA_M = CASE WHEN ISNULL(SUMMA_G,0) < ISNULL(LIMIT,0) THEN ISNULL(SUMMA_M,0)
				ELSE 
					CASE WHEN ISNULL(LIMIT,0) - (ISNULL(SUMMA_G,0) - ISNULL(SUMMA_M,0)) > 0 THEN 
						ISNULL(LIMIT,0) - (ISNULL(SUMMA_G,0) - ISNULL(SUMMA_M,0))
					ELSE 0
					END
			  END

UPDATE @T2_1 SET INV = ISNULL(INV,0) + ISNULL((SELECT SUM(SUMMA_M) FROM #DED_U WHERE MON = NUM),0)

-- 
--
DECLARE @T2 TABLE 
([NUM]				[int],
 [SUMMA]			[numeric](19, 2),
 [SUMMA_VKR]		[numeric](19, 2),
 [SUMMA_M]			[numeric](19, 2),
 [SUMMA_M_VKR]		[numeric](19, 2),
 [MP]				[numeric](19, 2),
 [MP_VKR]			[numeric](19, 2),
 [MP_M]				[numeric](19, 2),
 [MP_M_VKR]			[numeric](19, 2),
 [STATUS]			[int],
 [INV]				[numeric](19, 2),
 [INV_VKR]			[numeric](19, 2),
 [TARIF]			[TINYINT],
 [SPECO] [INT]
  ) --  

INSERT INTO @T2 ([NUM],[SUMMA],[SUMMA_VKR],[SUMMA_M],[SUMMA_M_VKR],[MP],[MP_VKR],[MP_M],[MP_M_VKR],[STATUS],[INV],[INV_VKR],[TARIF],[SPECO])
SELECT [NUM],[SUMMA],[SUMMA_VKR],[SUMMA_M],[SUMMA_M_VKR],[MP],[MP_VKR],[MP_M],[MP_M_VKR],[STATUS],[INV],
		 [INV_VKR] = (CASE WHEN (SUMMA_M - MP_M) = 0 THEN 0 ELSE (SUMMA_M_VKR - MP_M_VKR)*INV/(SUMMA_M - MP_M) END),
		 TARIF = CASE WHEN dbo.is_invalid(@linkFace,dbo.DateEndOfMonth(dbo.ConvertDMY2Date(1,NUM,@Year))) = 2 THEN 3 ELSE @TARIF END,
		 [SPECO] = (SELECT TOP 1 [COD_SPO_USL_TRUD] FROM #PERIODY 
						WHERE dbo.DateEndOfMonth(dbo.ConvertDMY2Date(1,NUM,@Year)) BETWEEN st_date1 AND st_date2
						AND dbo.DateEndOfMonth(dbo.ConvertDMY2Date(1,NUM,@Year)) BETWEEN im_date1 AND im_date2)
FROM 
	@T2_1

if @FlagShow = 1 
	select [num] as [], [summa] as [  /],summa_vkr as [  /  /], summa_m as [ ], 
	summa_m_vkr as [ . /], mp as [.], mp_vkr as [.  /],mp_m as [.  ],
	mp_m_vkr as [. . /], inv as [], inv_vkr as [  /], TARIF as [], [SPECO]  from @T2


DECLARE @WAY_CALC [int]
SELECT @WAY_CALC = WAY_CALC FROM dbo.PAYS WHERE LINK = @RefPay

DECLARE @Pred table  
(
 TARIF TINYINT,	
 [PREDEL]  [numeric](15, 2), 
 [PERCENT] [numeric](8, 2),
 WAY_CALC TINYINT,
 SPECO INT,
 NSPECO VARCHAR(254) )

IF @WAY_CALC<5
	
	IF @FlagMS = 1
		INSERT INTO @Pred (TARIF, [PREDEL],[PERCENT],SPECO,NSPECO)
		SELECT TARIF, [PREDEL],[PERCENT],SPECO=0,NSPECO='' FROM dbo.DICTIONARY_RANGE D
		WHERE
			(LINK_PAYS = @RefPay) 
			AND [DATE] = (SELECT TOP 1 [DATE] FROM dbo.DICTIONARY_RANGE D1 WHERE D1.TARIF = D.TARIF AND (LINK_PAYS = @RefPay) AND DATE < @DATE1 ORDER BY [DATE] DESC) 
		ORDER BY 1 
	ELSE 
		INSERT INTO @Pred (TARIF, [PREDEL],[PERCENT],SPECO,NSPECO)
		SELECT TOP 1 TARIF, [PREDEL] = 999999999999, [PERCENT],SPECO=0,NSPECO='' 
		FROM dbo.DICTIONARY_RANGE D
		WHERE 
			(LINK_PAYS = @RefPay) 
			AND [DATE] = (SELECT TOP 1 [DATE] FROM dbo.DICTIONARY_RANGE D1 WHERE D1.TARIF = D.TARIF AND (LINK_PAYS = @RefPay) AND DATE < @DATE1 ORDER BY [DATE] DESC) 
		ORDER BY 1 
ELSE 
BEGIN	
		
	DECLARE @Sex 		[int], 
			  @YearB 	[int], 
			  @Type 		[int]

	SELECT @Sex = SEX, @YearB = CASE WHEN RESIDENT = 1 THEN ISNULL(YEAR(BIRTHDATE),0) 
												ELSE 1966 END --      66   
											FROM dbo.PERSON WHERE LINK =@linkFace
	SET 	@Type = (CASE WHEN (@Sex = 1 AND @YearB < 1953) OR (@Sex = 2 AND @YearB<1957) THEN 1
						WHEN (@Sex = 1 AND @YearB BETWEEN 1953 AND 1966) OR (@Sex = 2 AND  @YearB BETWEEN 1957 AND 1966) THEN 2 
						ELSE 3 END)

	IF @FlagMS = 1 
		INSERT INTO @Pred (TARIF, [PREDEL],[PERCENT],WAY_CALC,SPECO,NSPECO)
		SELECT 
			TARIF,  
			[PREDEL],
			[PERCENT] = (CASE WHEN @Type = 1 THEN PERCENT1 WHEN @Type = 2 THEN PERCENT2 ELSE PERCENT3 END),
			WAY_CALC,
			SPECO,
			NSPECO
		FROM 
			dbo.DICTIONARY_RANGE_PF D
		WHERE
			LINK_PAYS = @RefPay 
			AND [DATE] = (SELECT TOP 1 [DATE] FROM dbo.DICTIONARY_RANGE_PF D1 WHERE D1.TARIF = D.TARIF AND ISNULL(D1.SPECO,0) = ISNULL(D.SPECO,0) AND LINK_PAYS = @RefPay AND DATE < @DATE1 ORDER BY [DATE] DESC) 
		ORDER BY 1 
	ELSE 
		INSERT INTO @Pred (TARIF, [PREDEL],[PERCENT],WAY_CALC,SPECO,NSPECO)
		SELECT TOP 1 
			TARIF, 
			[PREDEL] = 999999999999,
			[PERCENT] = (CASE WHEN @Type = 1 THEN PERCENT1 WHEN @Type = 2 THEN PERCENT2 ELSE PERCENT3 END),
			WAY_CALC,
			SPECO,NSPECO
		FROM 
			dbo.DICTIONARY_RANGE_PF D
		WHERE
			LINK_PAYS = @RefPay 
			AND [DATE] = (SELECT TOP 1 [DATE] FROM dbo.DICTIONARY_RANGE_PF D1 WHERE D1.TARIF = D.TARIF AND ISNULL(D1.SPECO,0) = ISNULL(D.SPECO,0) AND LINK_PAYS = @RefPay AND DATE < @DATE1 ORDER BY [DATE] DESC) 
		ORDER BY 1 
	END

IF @FlagShow = 1 
	select TARIF as [], Predel as [], [Percent] as [], NSPECO AS [] from @Pred P
	WHERE EXISTS (SELECT * FROM @T2 B WHERE B.TARIF = P.TARIF AND ISNULL(B.[SPECO],0) = ISNULL(P.[SPECO],0))

DECLARE @res TABLE
([NUM]			[int],
 [SUMMA]		[numeric] (19, 2),
 [SUMMA_M_VKR]	[numeric] (19, 2),
 [PERC]			[numeric] (19, 2),
 [SUM_MON]		[numeric] (19, 2),
 [TARIF]		INT,
 [SPECO]		INT)

INSERT INTO @res([NUM],[SUMMA],[SUMMA_M_VKR],[PERC],[SUM_MON],[TARIF],[SPECO])
SELECT T7.[NUM],T7.[SUMMA],T7.[SUMMA_M_VKR],T7.[PERC], CAST(0 as numeric(15,2)) AS SUM_MON, [TARIF], [SPECO]
FROM  
	(
	SELECT 
		[NUM], 
		[SUMMA] 		 = SUMMA - MP, 
		[SUMMA_M_VKR] = SUMMA_M_VKR - MP_M_VKR,	
		[PERC] 		 = ISNULL((SELECT TOP 1 T.[PERCENT] FROM (SELECT TOP 1 * FROM @Pred P WHERE B.TARIF = P.TARIF AND ISNULL(B.SPECO,0) = ISNULL(P.[SPECO],0) AND PREDEL > (SUMMA - MP + @SUM_DGH) ORDER BY PREDEL) T),0),
		B.[TARIF],
		B.[SPECO]
	 FROM @T2	B
	 UNION
	 SELECT DISTINCT
		[NUM] 			= ISNULL((SELECT MIN(NUM) FROM @T2 B1 WHERE B1.TARIF = B.TARIF AND ISNULL(B1.[SPECO],0) = ISNULL(B.[SPECO],0) AND (SUMMA-MP+@SUM_DGH) > PREDEL),12), 
		[SUMMA] 		= PREDEL - @SUM_DGH, 
		[SUMMA_M_VKR]= 0, 
		[PERC] 		= [PERCENT],  
		B.[TARIF],
		B.[SPECO]		
 	 FROM 
 		@T2 B INNER JOIN @Pred T ON B.TARIF = T.TARIF AND ISNULL(B.[SPECO],0) = ISNULL(T.[SPECO],0)
 	 WHERE 
 		PREDEL < (SELECT TOP 1 (SUMMA - MP + @SUM_DGH) FROM @T2 B1 WHERE B1.TARIF = B.TARIF AND ISNULL(B1.[SPECO],0) = ISNULL(B.[SPECO],0) ORDER BY 1 DESC)
 	) T7


DECLARE Curs CURSOR FAST_FORWARD FOR
SELECT NUM,SUMMA FROM @res ORDER BY [NUM]  

DECLARE @Summa [numeric] (19, 2), 
	@summa_prev [numeric] (19, 2), 
	@num1 [int]


SET @summa_prev = 0
OPEN Curs
FETCH NEXT FROM Curs INTO @num1, @Summa
WHILE @@FETCH_STATUS = 0 BEGIN
	UPDATE @res SET SUM_MON = @Summa - @summa_prev WHERE NUM = @num1 AND SUMMA = @Summa
	SET @summa_prev = @Summa
  	FETCH NEXT FROM Curs INTO @num1, @Summa
END
CLOSE Curs
DEALLOCATE Curs

DECLARE @Result1 TABLE
([NUM]			[int],
 [SUMMA]			[numeric] (19, 2),
 [SUMMA_M_VKR]	[numeric] (19, 2),
 [PERC]			[numeric] (19, 2),
 [SUM_MON]		[numeric] (19, 2),
 [SKIDKA]		[numeric] (19, 2),
 [KOEF]			[numeric] (19, 10), 
 [TARIF]		INT,
 [SPECO]		INT)


INSERT INTO @Result1 ([NUM],[SUMMA],[SUMMA_M_VKR],[PERC],[SUM_MON],[SKIDKA],[KOEF], [TARIF], [SPECO])
SELECT [NUM],[SUMMA],[SUMMA_M_VKR],[PERC],[SUM_MON],
		 [SKIDKA] = dbo.is_min(T1.SUM_MON, ISNULL((SELECT INV FROM @T2 T4  WHERE T4.NUM = T1.NUM),0)  
						- ISNULL((SELECT SUM(T3.SUM_MON) FROM @res T3 WHERE T3.NUM = T1.NUM AND T3.SUMMA < T1.SUMMA), 0)),
		 [KOEF] = (SELECT (CASE WHEN (SUMMA_M - MP_M) = 0 THEN 0 ELSE (SUMMA_M_VKR - MP_M_VKR)/(SUMMA_M - MP_M) END) FROM @T2 T2 WHERE T2.NUM = T1.NUM),
		 [TARIF], [SPECO]
FROM @res T1

DECLARE @RESULT TABLE
([NUM]			[int],
 [SUMMA]			[numeric] (19, 2),
 [SUMMA_M_VKR]	[numeric] (19, 2),
 [PERC]			[numeric] (19, 2),
 [SUM_MON]		[numeric] (19, 2),
 [SKIDKA]		[numeric] (19, 2),
 [KOEF]			[numeric] (19, 10),
 [VYCH] 		[numeric] (19, 2),
 [TARIF]		INT,
 [SPECO]		INT)

INSERT INTO @RESULT ([NUM],[SUMMA],[SUMMA_M_VKR],[PERC],[SUM_MON],[SKIDKA],[KOEF], [TARIF], [SPECO])
SELECT [NUM],[SUMMA],[SUMMA_M_VKR],[PERC],[SUM_MON],
		 [SKIDKA] = (CASE WHEN SKIDKA < 0 THEN 0 ELSE SKIDKA END),
		 [KOEF], [TARIF], [SPECO]
FROM @Result1

DECLARE @Razn 			[numeric](15, 2), 
	  @NalCurr 	[numeric](15, 2),
	  @Sum1 		[numeric](15, 2)

--  
SET @NalCurr = (SELECT sum(ROUND((PERC * (COALESCE(SUM_MON,0) - COALESCE(SKIDKA,0))* COALESCE(KOEF,0)/100) * 100, 2) / 100) FROM @RESULT )

--   
SET @Sum1 = ISNULL((SELECT SUM(SJ.SUMMA) FROM dbo.S_J_C_Short SJ 
WHERE 
	SJ.LINK_VKR = @LinkVKR 
	AND SJ.LINK_VKR2 = @LinkVKR2
	--AND ( (SJ.LINK_EKR IN (@LINK_EKR,@LINK_EKR_ADD) AND @LINK_EKR <> @LINK_211EKR) OR (@LINK_EKR = @LINK_211EKR AND SJ.LINK_EKR IN (@LINK_211EKR,@LINK_213EKR)) )
	AND ( (SJ.LINK_EKR IN (@LINK_EKR,@LINK_EKR_ADD) AND @LINK_EKR <> @LINK_211EKR) OR (@LINK_EKR = @LINK_211EKR AND SJ.LINK_EKR = @LINK_EKR) )
	AND SJ.LINK_PAYS = @RefPay 
	AND (SJ.LINK_FACE = @linkFace) 
	AND MONTH_BEGIN <= @Month 
	AND YEAR_BEGIN=@Year 
	AND sj.LINK_DEP = @DEP_LINK),0)

--IF --      < 0
--	(SELECT SUM(SUMMA) FROM @RESULT) < 0 
--		--AND @Sum1 = 0 
--		--      < 0
--		AND @NalCurr < 0
--	SET @NalCurr = 0
	
SET @Razn = @NalCurr - @Sum1

DECLARE @FLG INT
SELECT TOP 1 @FLG = ISNULL(CONVERT(INT,VALUE),0) 
FROM S_OPTIONS WHERE OBJECT = (SELECT TOP 1 LINK FROM S_OBJECTS WHERE CODE = 'ESN_OPTIONS_FLG') AND SID IS NULL

IF @Razn <0 AND @FLG = 0
	SET @Razn=0

SELECT [SUMMA] 		= ISNULL(SUMMA_VKR,0), 
	 [SUMMA_VKR] 	= ISNULL(SUMMA_M_VKR, 0),
	 [SUM_DED] 		=	CASE WHEN ISNULL(SUMMA_VKR, 0) > 0 
						THEN
							ISNULL((SELECT TOP 1 MP_VKR FROM @T2 WHERE NUM = @Month), 0)
						ELSE 0 END,	
	 [INV_M] 		= CASE WHEN ISNULL(SUMMA_VKR, 0) > 0 
						THEN
							ISNULL((SELECT SUM(SKIDKA*KOEF) FROM @RESULT WHERE NUM = @Month),0)
						ELSE 0 END,
	 [INV] 			= CASE WHEN ISNULL(SUMMA_VKR, 0) > 0 
						THEN
							ISNULL((SELECT SUM(SKIDKA*KOEF) FROM @RESULT WHERE NUM <= @Month),0)
						ELSE 0 END,
	 [DED_M] 		= CASE WHEN ISNULL(SUMMA_VKR, 0) > 0 
						THEN
							ISNULL((SELECT TOP 1 MP_M_VKR FROM @T2 WHERE NUM = @Month), 0)
						ELSE 0 END,
	 [PERC]			= ISNULL((SELECT MIN(PERC) FROM @RESULT WHERE NUM = @Month),0),
	 [NALOG] 		= @NalCurr, 
	 [NAL_DED] 		= @Sum1, 
	 [NAL_CUR] 		= @Razn,
	 [TARIF]		= ISNULL((SELECT MIN([TARIF]) FROM @RESULT WHERE NUM = @Month),0), 
	 [SPECO]		= ISNULL((SELECT MIN([SPECO]) FROM @RESULT WHERE NUM = @Month),0),
	 [NSPECO]		= (SELECT TOP 1 CODE FROM dbo.SZV4_SPR WHERE LINK = ISNULL((SELECT MIN([SPECO]) FROM @RESULT WHERE NUM = @Month),0) )
FROM 
	@T1 
WHERE 
	NUM = @Month

SET NOCOUNT OFF





GO


GRANT EXECUTE ON dbo.[SALARY_FILL_DED_ESN_VKR] TO PUBLIC

GO


-- --


GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SD_EMPL_INCOM_VKR]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[SD_EMPL_INCOM_VKR]

GO
CREATE   PROCEDURE [dbo].SD_EMPL_INCOM_VKR
	@VARKSNMODE	SMALLINT	= 0, 
	@VARKSNMONTH INT		= 0,
	@VARKSNYEAR	INT		= 0,
	@DEP_LINK INT = NULL,
	@DO_EKR TINYINT = 0 --  
AS

IF @DEP_LINK IS NULL
	EXEC DBO.XD_WHATS_ZB @DEP_LINK OUTPUT
	
DECLARE @LINK_211EKR INT, @LINK_R211EKR INT, @LINK_212EKR INT, @SHOW_212 TINYINT, @LINK_213EKR INT
		  
SET @LINK_211EKR = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '211')
SET @LINK_R211EKR = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = 'R211')
SET @LINK_212EKR = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '212')
SET @LINK_213EKR = (SELECT TOP 1 LINK FROM dbo.KOSGU WHERE CODE = '213')
SET @SHOW_212 = dbo.SA_GET_OPTION_BY_CODE('ESN_OPTIONS_3')

DECLARE @ESN_213 INT --      213                                                     
SET @ESN_213 = dbo.SA_GET_OPTION_BY_CODE('ESN_OPTIONS_5')


/*         
  ,  ,   */
	
IF OBJECT_ID('TEMPDB..#EMPLS1','U') IS NOT NULL
DROP TABLE #EMPLS1

CREATE TABLE #EMPLS1 (DEP_LINK INT, PERS_LINK INT, LINK INT, TAB VARCHAR(254), NUM INT, LINK_EMPL2 INT)

INSERT INTO #EMPLS1 (DEP_LINK, PERS_LINK, LINK, TAB, NUM)
SELECT E.DEP_LINK, E.PERS_LINK, E.LINK, E.TAB, NUM = ROW_NUMBER () OVER (PARTITION BY E.DEP_LINK, E.PERS_LINK ORDER BY DATE_BEGIN DESC)
	FROM dbo.EMPL E INNER JOIN dbo.ITEM_MOVE IM ON E.LINK = IM.EMPL_LINK
		WHERE IM.ACTIVE = 1 AND IM.NEW_FACE=1 AND (IM.[STATUS]=1 OR IM.[STATUS]=3) AND DATE_BEGIN <= dbo.DateEndOfMonth(dbo.ConvertDMY2Date(1,@VARKSNMONTH,@VARKSNYEAR))
		--AND PERS_LINK = 17896

UPDATE A SET A.LINK_EMPL2 = B.LINK
FROM #EMPLS1 A INNER JOIN #EMPLS1 B ON A.DEP_LINK = B.DEP_LINK AND A.PERS_LINK = B.PERS_LINK
WHERE B.NUM = 1
		
/*      */

IF OBJECT_ID('TEMPDB..#EMPLS2','U') IS NOT NULL
DROP TABLE #EMPLS2

CREATE TABLE #EMPLS2 (DEP_LINK INT, PERS_LINK INT, LINK INT, TAB VARCHAR(254), NUM INT, LINK_EMPL2 INT)

INSERT INTO #EMPLS2 (DEP_LINK, PERS_LINK, LINK, TAB, NUM)
SELECT E.DEP_LINK, E.PERS_LINK, E.LINK, E.TAB, NUM = 1
	FROM dbo.EMPL E INNER JOIN dbo.ITEM_MOVE IM ON E.LINK = IM.EMPL_LINK
		WHERE IM.ACTIVE = 1 AND IM.NEW_FACE=1 AND IM.[STATUS]=2 AND DATE_BEGIN <= dbo.DateEndOfMonth(dbo.ConvertDMY2Date(1,@VARKSNMONTH,@VARKSNYEAR))
		--AND PERS_LINK = 17896

UPDATE A SET A.LINK_EMPL2 = B.LINK
FROM #EMPLS2 A INNER JOIN #EMPLS2 B ON A.DEP_LINK = B.DEP_LINK AND A.PERS_LINK = B.PERS_LINK
WHERE B.NUM = 1

SELECT 
	T.LINK,
	T.LINK_EMPL,
	T.TAB_NUM,
	T.[NAME_EMPL], 
	T.[STATUS],
	T.NUM_STAKE,	
	LINK_VKR = ISNULL(SF.LINK_SS_SFIN, T.LINK_VKR),
	NAME_VKR = ISNULL(SF2.CODE, T.NAME_VKR),
	T.LINK_EKR,
	T.CODE_EKR,
	LINK_VKR2 = T.LINK_VKR,
	NAME_VKR2 = T.NAME_VKR
FROM
(			
SELECT DISTINCT
	LINK= E.PERS_LINK,
	LINK_EMPL= E.LINK,
	TAB_NUM= E.TAB,
	[NAME_EMPL]= RTRIM(P.FM) + ' ' + SUBSTRING(RTRIM(P.IM),1,1) + '.' + SUBSTRING(RTRIM(P.OT),1,1) + '.', 
	[STATUS] = 1,
	NUM_STAKE = 1,	
	JC.LINK_VKR, 
	NAME_VKR = KBK.CODE,
	LINK_EKR = EKR.LINK,
	CODE_EKR = EKR.CODE
FROM
	DBO.PERSON P with (nolock)
	INNER JOIN DBO.EMPL E with (nolock) ON E.PERS_LINK = P.LINK AND E.DEP_LINK = COALESCE(@DEP_LINK,E.DEP_LINK)
	--      
	INNER JOIN (
		/*         
		  ,  ,   */
		SELECT DEP_LINK, LINK, LINK_EMPL2 FROM #EMPLS1
		/*      */
		UNION
		SELECT DEP_LINK, LINK, LINK_EMPL2 FROM #EMPLS2
			) T ON T.DEP_LINK = E.DEP_LINK AND T.LINK_EMPL2 = E.LINK
	INNER JOIN dbo.CALCULATE_JURNAL JC ON JC.LINK_EMPL = T.LINK
	INNER JOIN dbo.PAYS PS ON JC.LINK_PAYS = PS.LINK
	INNER JOIN DBO.SAL_SFIN KBK ON JC.LINK_VKR = KBK.LINK
	INNER JOIN DBO.KOSGU EKR ON 
		@SHOW_212 = 1 AND (EKR.LINK = JC.LINK_EKR OR (JC.LINK_EKR = @LINK_212EKR AND EKR.LINK = @LINK_211EKR)) --  212    211  --   
		OR 
		@SHOW_212 = 0 AND EKR.LINK = (CASE WHEN JC.LINK_EKR <> @LINK_212EKR THEN JC.LINK_EKR ELSE @LINK_211EKR END)	
		OR 
		@DO_EKR = 1 AND EKR.LINK = JC.LINK_EKR
WHERE
	EXISTS ( SELECT * FROM dbo.TAX_REF TR INNER JOIN dbo.PAYS P1 ON P1.LINK = TR.LINK_TAX WHERE P1.[OBJECT] = 3 AND TR.LINK_PAYS = JC.LINK_PAYS)
	AND
	E.DEP_LINK = @DEP_LINK
	AND
	PS.[OBJECT] = 1
	AND
	YEAR(JC.PERIOD_BEGIN) = @VARKSNYEAR
	AND
	JC.SUMMA<>0
	AND
	(
		(MONTH(JC.PERIOD_BEGIN) <= @VARKSNMONTH AND @VARKSNMODE <> 0)
		OR
		(MONTH(JC.PERIOD_BEGIN) = @VARKSNMONTH AND @VARKSNMODE = 0)
	)
	AND
	(@ESN_213 = 1 OR @ESN_213 = 0 AND EKR.LINK <> @LINK_213EKR)
) T
INNER JOIN dbo.SAL_SFIN SF ON SF.LINK = T.LINK_VKR
LEFT JOIN dbo.SAL_SFIN SF2 ON SF2.LINK = SF.LINK_SS_SFIN
--WHERE LINK_EMPL = 123	
ORDER BY
	4,6,8


GO


GRANT EXECUTE ON dbo.[SD_EMPL_INCOM_VKR] TO PUBLIC

GO

GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SD_O_ESN_TABLE_SAVE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[SD_O_ESN_TABLE_SAVE]

GO

/*
  (Keysystems), 2005
*/
CREATE PROCEDURE dbo.SD_O_ESN_TABLE_SAVE
	@intLINK				int,
	@intORDERS			int,
	@intLINK_EMPL		int,
	@numSUMMA_BASE 	numeric(18,2)=0.0,
	@numCALC_TAX		numeric(18,2)=0.0,
	@numDED_M			numeric(18,2)=0.0,
	@numINV_M			numeric(18,2)=0.0,
	@numSUM_DED 		numeric(18,2)=0.0,
	@numSUMMA			numeric(18,2)=0.0,
	@numTOTAL_DED		numeric(18,2)=0.0,
	@numTOTAL_SUM		numeric(18,2)=0.0,
	@numTOTAL_TAX		numeric(18,2)=0.0, 
	@intLINK_PAY		int,
	@intLINK_VKR 		int,
	@LINK_EKR			INT,
	@DEL				TINYINT = 0,
	@PERC				numeric(18,2)=0.0,
	@TARIF				INT=null,	
	@SPECO				INT = null,
	@intLINK_VKR2 		int = NULL

AS
DECLARE @SQLError			tinyint,
		  @trancount	int,		
		  @strVALUE		varchar(7000),
		  @tintSTATUS	int,
		  @RowCount		int,
		  @linkFace 	int	

SET @trancount = @@TRANCOUNT

SET IMPLICIT_TRANSACTIONS ON
BEGIN TRAN
COMMIT TRAN

IF @intLINK_VKR2 IS NULL
	SET @intLINK_VKR2 = @intLINK_VKR

SELECT @linkFace = PERS_LINK FROM dbo.EMPL WHERE LINK = @intLINK_EMPL
SELECT @tintSTATUS = dbo.IS_INVALID(@linkFace,dbo.SalaryPeriodCalcBegin())

IF @intLINK_EMPL IS NULL OR @intLINK_PAY IS NULL OR @intLINK_VKR IS NULL OR @LINK_EKR IS NULL
BEGIN
	ROLLBACK
	RETURN 8
END

IF ISNULL(@DEL,0) = 0

	IF NOT EXISTS (SELECT LINK_UP FROM DBO.SDOC_ESN_TABLE 
							WHERE LINK_UP = @intLINK AND LINK_EMPL = @intLINK_EMPL 
								AND LINK_PAY = @intLINK_PAY AND LINK_VKR = @intLINK_VKR AND LINK_VKR2 = @intLINK_VKR2
								AND LINK_EKR = @LINK_EKR)
								
		INSERT INTO SDOC_ESN_TABLE WITH (ROWLOCK) (LINK_UP,ORDERS,LINK_EMPL,SUMMA_BASE,CALC_TAX,DED_M,INV_M,SUM_DED,SUMMA, TOTAL_DED,TOTAL_SUM,TOTAL_TAX,LINK_PAY,LINK_VKR,[STATUS],LINK_EKR, PERC, TARIF, SPECO, LINK_VKR2)
		VALUES (@intLINK,@intORDERS,@intLINK_EMPL,@numSUMMA_BASE,@numCALC_TAX,@numDED_M,@numINV_M,@numSUM_DED,@numSUMMA,
				@numTOTAL_DED,@numTOTAL_SUM,@numTOTAL_TAX,@intLINK_PAY,@intLINK_VKR,@tintSTATUS,@LINK_EKR, @PERC, @TARIF, @SPECO, @intLINK_VKR2)

	ELSE
		UPDATE 
			DBO.SDOC_ESN_TABLE
		SET
			ORDERS = @intORDERS,
			SUMMA_BASE = @numSUMMA_BASE,
			CALC_TAX = @numCALC_TAX,
			DED_M = @numDED_M,
			INV_M = @numINV_M,
			SUM_DED = @numSUM_DED,
			SUMMA = @numSUMMA, 
			TOTAL_DED = @numTOTAL_DED,
			TOTAL_SUM = @numTOTAL_SUM,
			TOTAL_TAX = @numTOTAL_TAX,
			[STATUS] = @tintSTATUS,
			PERC = @PERC,
			TARIF = @TARIF,
			SPECO = @SPECO
		WHERE 
			LINK_UP = @intLINK AND LINK_EMPL = @intLINK_EMPL AND LINK_PAY = @intLINK_PAY AND LINK_VKR = @intLINK_VKR AND LINK_VKR2 = @intLINK_VKR2 AND LINK_EKR = @LINK_EKR
ELSE
		DELETE FROM DBO.SDOC_ESN_TABLE
		WHERE LINK_UP = @intLINK AND LINK_EMPL = @intLINK_EMPL AND LINK_PAY = @intLINK_PAY AND LINK_VKR = @intLINK_VKR AND LINK_EKR = @LINK_EKR

SELECT @SQLError = @@ERROR, @intLINK = @@IDENTITY
IF @SQLError <> 0
BEGIN
	ROLLBACK
	RETURN 7
END

WHILE @@TRANCOUNT > @trancount
	COMMIT TRAN
RETURN 0




GO


GRANT EXECUTE ON dbo.[SD_O_ESN_TABLE_SAVE] TO PUBLIC

GO

GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SD_O_ESN_PROV]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[SD_O_ESN_PROV]

GO

/*
  (Keysystems), 2005
*/
CREATE PROCEDURE dbo.SD_O_ESN_PROV

@varKSparLINK int
AS

IF (SELECT SO.CODE FROM S_OBJECTS SO,SDOC DOC WHERE DOC.LINK = @varKSparLINK AND
		 DOC.OBJECT = SO.LINK) <> 'DOCUMENTS_DEDUCT_ESN_G'
	RETURN 5

IF EXISTS (SELECT * FROM DBO.CALCULATE_JURNAL WHERE LINK_DOC = @varKSparLINK)
BEGIN
		RAISERROR('  !', 11, 1)
		RETURN 0
END	

Declare @varKStrancount int

SET @varKStrancount = @@TRANCOUNT
SET IMPLICIT_TRANSACTIONS ON
BEGIN TRAN
COMMIT TRAN


DECLARE @LinkEKR213 int
SELECT @LinkEKR213 = LINK FROM dbo.DICTIONARY_ITEM WHERE CODE = '213'

EXEC dbo.SALARY_SDOC_FLAG_JC @varKSparLINK,0

INSERT INTO dbo.CALCULATE_JURNAL (LINK_EMPL,LINK_PAYS,LINK_DOC,PERIOD_BEGIN,PERIOD_END,DAYS,HOURS,SUMMA_BASE,SUMMA,ORDERS,DATE_BEGIN,DATE_END,LINK_DEP,LINK_ORG,LINK_VKR,LINK_EKR,TARIF,SPECO,PROCENT,LINK_VKR2)
SELECT 
		[LINK_EMPL] = T.LINK_EMPL,
		[LINK_PAYS] = T.LINK_PAY,
		[LINK_DOC] = s.LINK,
	  	[PERIOD_BEGIN] = dbo.DateBeginOfMonth(s.DATE),	
		[PERIOD_END] = dbo.DateEndOfMonth(s.DATE),	
		[DAYS] =0,
		[HOURS] = 0,
		[SUMMA_BASE] = T.SUMMA_BASE,
		[SUMMA] = T.SUMMA,
		[ORDERS] = T.ORDERS,
		[DATE_BEGIN] = dbo.DateBeginOfMonth(S.DATE_CALC), 
		[DATE_END] = dbo.DateEndOfMonth(S.DATE_CALC), 
		[LINK_DEP] = S.LINK_DEP,
		[LINK_ORG] = NULL,
		[LINK_VKR] = T.LINK_VKR,
		T.LINK_EKR,--CASE WHEN E.CODE IN ('211') THEN @LinkEKR213 ELSE T.LINK_EKR END
		T.TARIF,
		T.SPECO,
		T.PERC,
		ISNULL(T.[LINK_VKR2],T.[LINK_VKR])
FROM 
	dbo.SDOC S
	inner join dbo.SDOC_ESN_TABLE T on S.link = T.LINK_UP
	inner join dbo.USER_INFO UI on 1=1
	INNER JOIN dbo.KOSGU E ON E.LINK = T.LINK_EKR
WHERE 
	UI.SID = SUSER_SID() 
	and s.LINK = @varKSparLINK 
	and T.SUMMA<>0


EXEC dbo.SALARY_SDOC_FLAG_JC @varKSparLINK,1


IF @@TRANCOUNT > @varKStrancount
	COMMIT TRAN
RETURN 0

GO


GRANT EXECUTE ON dbo.[SD_O_ESN_PROV] TO PUBLIC

GO

GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SD_O_OTHER_PROV]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[SD_O_OTHER_PROV]

GO

/*
  (Keysystems), 2005
*/
CREATE  PROCEDURE dbo.SD_O_OTHER_PROV
@varKSparLINK int
AS

IF (SELECT SO.CODE FROM S_OBJECTS SO,SDOC DOC WHERE DOC.LINK = @varKSparLINK AND
		 DOC.OBJECT = SO.LINK) <> 'DOCUMENTS_CLOSE_MONTH'
	RETURN 5

IF EXISTS (SELECT * FROM DBO.CALCULATE_JURNAL WHERE LINK_DOC = @varKSparLINK)
BEGIN
		RAISERROR('  !', 11, 1)
		RETURN 0
END

Declare @varKStrancount int

SET @varKStrancount = @@TRANCOUNT
SET IMPLICIT_TRANSACTIONS ON
BEGIN TRAN
COMMIT TRAN

EXEC dbo.SALARY_SDOC_FLAG_JC @varKSparLINK,0

DECLARE @LinkEKR213 int
SELECT @LinkEKR213 = LINK FROM dbo.DICTIONARY_ITEM WHERE CODE = '213'

INSERT INTO dbo.CALCULATE_JURNAL (LINK_EMPL,LINK_PAYS,LINK_DOC,PERIOD_BEGIN,PERIOD_END,DAYS,HOURS,SUMMA_BASE,PROCENT,SUMMA,ORDERS,DATE_BEGIN,DATE_END,LINK_DEP,LINK_ORG,LINK_VKR,LINK_EKR,LINK_VKR2)
SELECT [LINK_EMPL] =NULL,
		[LINK_PAYS] = TAB.REF_DED,
		[LINK_DOC] = DOC.LINK,
	  	[PERIOD_BEGIN] = dbo.DateBeginOfMonth(DOC.DATE),	
		[PERIOD_END] = dbo.DateEndOfMonth(DOC.DATE),	
		[DAYS] =0,
		[HOURS] = 0,
		[SUMMA_BASE] = TAB.SUMMA_BASE,
		[PERCENT],
		[SUMMA] = TAB.SUMMA,
		[ORDERS] = TAB.ORDERS,
		[DATE_BEGIN] = dbo.DateBeginOfMonth(CONVERT(DATETIME,('01/'+ RTRIM(DOC.MONTH)+'/'+RTRIM(DOC.YEAR)))), 
		[DATE_END] = dbo.DateEndOfMonth(CONVERT(DATETIME,('01/'+ RTRIM(DOC.MONTH)+'/'+RTRIM(DOC.YEAR)))), 
		[LINK_DEP] = LINK_DEP,
		[LINK_ORG] = NULL,
		[LINK_VKR] = TAB.LINK_VKR,
		[LINK_EKR] = TAB.LINK_EKR,
		[LINK_VKR2] = TAB.LINK_VKR2		
FROM dbo.DOCUMENTS_DED_OTHER DOC, dbo.DOCUMENTS_DED_OTHER_TABLE TAB, dbo.USER_INFO UI
WHERE UI.SID = SUSER_SID() AND DOC.LINK = TAB.LINK  AND  DOC.LINK = @varKSparLINK and TAB.SUMMA<>0


EXEC dbo.SALARY_SDOC_FLAG_JC @varKSparLINK,1


IF @@TRANCOUNT > @varKStrancount
	COMMIT TRAN
RETURN 0

GO


GRANT EXECUTE ON dbo.[SD_O_OTHER_PROV] TO PUBLIC

GO

GO

--AFTER CODE 20.04.2016
/*   2016     */
ALTER TABLE dbo.CALCULATE_JURNAL DISABLE TRIGGER ALL

---
DELETE J
FROM
	dbo.SDOC S
	INNER JOIN dbo.CALCULATE_JURNAL J ON J.LINK_DOC = S.LINK
WHERE 
	EXISTS (SELECT * FROM dbo.S_OBJECTS O WHERE O.CODE = 'DOCUMENTS_DEDUCT_ESN_G' AND O.LINK = S.[OBJECT])
	AND
	YEAR(s.DATE) = 2016

---
INSERT INTO dbo.CALCULATE_JURNAL (LINK_EMPL,LINK_PAYS,LINK_DOC,PERIOD_BEGIN,PERIOD_END,DAYS,HOURS,SUMMA_BASE,SUMMA,ORDERS,DATE_BEGIN,DATE_END,LINK_DEP,LINK_ORG,LINK_VKR,LINK_EKR,TARIF,SPECO,PROCENT,LINK_VKR2)
SELECT 
		[LINK_EMPL] = T.LINK_EMPL,
		[LINK_PAYS] = T.LINK_PAY,
		[LINK_DOC] = s.LINK,
	  	[PERIOD_BEGIN] = dbo.DateBeginOfMonth(s.DATE),	
		[PERIOD_END] = dbo.DateEndOfMonth(s.DATE),	
		[DAYS] =0,
		[HOURS] = 0,
		[SUMMA_BASE] = T.SUMMA_BASE,
		[SUMMA] = T.SUMMA,
		[ORDERS] = T.ORDERS,
		[DATE_BEGIN] = dbo.DateBeginOfMonth(S.DATE_CALC), 
		[DATE_END] = dbo.DateEndOfMonth(S.DATE_CALC), 
		[LINK_DEP] = S.LINK_DEP,
		[LINK_ORG] = NULL,
		[LINK_VKR] = T.LINK_VKR,
		T.LINK_EKR,
		T.TARIF,
		T.SPECO,
		T.PERC,
		ISNULL(T.[LINK_VKR2],T.[LINK_VKR])
FROM 
	dbo.SDOC S
	inner join dbo.SDOC_ESN_TABLE T on S.link = T.LINK_UP
	INNER JOIN dbo.KOSGU E ON E.LINK = T.LINK_EKR
WHERE 
	YEAR(s.DATE) = 2016
	AND T.SUMMA<>0
	AND S.FLAG_JC = 1

ALTER TABLE dbo.CALCULATE_JURNAL ENABLE TRIGGER ALL
GO

GO


IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[SA_SZVM_EXPORT_v2_40]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[SA_SZVM_EXPORT_v2_40]

GO

/*EXEC dbo.BK_SELECT_EXPORT_FORMAT 2486*/
/*exec [dbo].[SA_SZVM_EXPORT_v2_40]       42451*/
CREATE      PROCEDURE [dbo].SA_SZVM_EXPORT_v2_40 ( @Link int /*  */ )
AS

CREATE TABLE #OUTPUT (ID int identity(1,1), F_NAME VARCHAR(254), OUT_TEXT TEXT)

SET NOCOUNT  ON

-- 
CREATE TABLE #TASK_PROP (ID int identity(1,1), VAL VARCHAR (254))


INSERT INTO #TASK_PROP (VAL) exec dbo.X_GET_PROP_CLIENT 'PROJECT','VERSION_MAJOR',1
INSERT INTO #TASK_PROP (VAL) exec dbo.X_GET_PROP_CLIENT 'PROJECT','VERSION_MINOR',1
INSERT INTO #TASK_PROP (VAL) exec dbo.X_GET_PROP_CLIENT 'PROJECT','VERSION_FIX',1

declare @NAME_PROG varchar(254), @VERS_PROG VARCHAR(254)
Select @NAME_PROG = UPPER(RTRIM(LTRIM([NAME]))),
	@VERS_PROG = (SELECT RTRIM(LTRIM(VAL)) FROM #TASK_PROP WHERE [ID] = 1)
	+ (SELECT REPLACE(STR(RTRIM(LTRIM(VAL)),2),' ','0') FROM #TASK_PROP WHERE [ID] = 2)
	+ (SELECT REPLACE(STR(RTRIM(LTRIM(VAL)),2),' ','0') FROM #TASK_PROP WHERE [ID] = 3)
from dbo.DICTIONARY_TASK where CODE = 'SALARY'
--------------------------------------------


DECLARE @LINK_DEP INT, @YEAR INT, @Version TINYINT, @Period_Number TINYINT, @LINK_FORM INT,
		@Begin_Date DATETIME, @End_Date DATETIME, @modify_date DATETIME
SELECT
	@LINK_DEP = LINK_ORGANIZATION,
	@YEAR = YEAR(Begin_Date),
	@Version = [Version],
	@Period_Number = Period_Number,
	@LINK_FORM = LINK_FORM,
	@Begin_Date = dbo.DateBeginOfYear(Begin_Date),
	@End_Date = Begin_Date,
	@modify_date = modify_date
FROM dbo.REPORT_SAVED_FORMS
WHERE LINK_SAVED_FORM = @link


DECLARE
	@first_month_of_quarter TINYINT,
	@second_month_of_quarter TINYINT,
	@third_month_of_quarter TINYINT

IF @Period_Number = 1
	SELECT @first_month_of_quarter = 1, @second_month_of_quarter = 2, @third_month_of_quarter = 3
IF @Period_Number = 2
	SELECT @first_month_of_quarter = 4, @second_month_of_quarter = 5, @third_month_of_quarter = 6
IF @Period_Number = 3
	SELECT @first_month_of_quarter = 7, @second_month_of_quarter = 8, @third_month_of_quarter = 9
IF @Period_Number = 4
	SELECT @first_month_of_quarter = 10, @second_month_of_quarter = 11, @third_month_of_quarter = 12

SELECT  @first_month_of_quarter = ISNULL(@first_month_of_quarter,1), @second_month_of_quarter = ISNULL(@second_month_of_quarter,2), @third_month_of_quarter = ISNULL(@third_month_of_quarter,3)


SELECT top 1
	DD1.OKPO AS OKPO1,
	DD1.INN AS INN1, DD1.KPP AS KPP1,
	FULL_NAME = UPPER(DD1.FULL_NAME),
	UPPER(DD1.NAME) AS ORGNAME,
	DD2.NALOG AS IMNS_SONO, DD2.NAME AS IMNS_NAME,
	DD2.NALOG AS SONO,
	DD1.OGRN AS OGRN1,
	LTRIM(RTRIM(dbo.GetAddressBykladr(DD1.REF_LINK_A)))
		+ CASE WHEN ISNULL(DD1.HOUSE, '') = '' THEN '' ELSE  ' ' + LTRIM(RTRIM(DD1.HOUSE)) END
		+ CASE WHEN ISNULL(DD1.FLAT, '') = '' THEN '' ELSE ' - ' + LTRIM(RTRIM(DD1.FLAT)) END
	AS ADDR_STR,
	CAST(NULL AS DATETIME) AS DATE_END,
	UPPER(RTRIM(CHIEF.FM) + ' ' + LEFT(CHIEF.IM, 1) + '. ' + LEFT(CHIEF.OT,1) + '.') AS CHIEF_FIO,
	CHIEF.FM as CHIEF_FM,
	CHIEF.IM as CHIEF_IM,
	CHIEF.OT as CHIEF_OT,
	RTRIM(CHIEF.PHONE) AS CH_PHONE,
	UPPER(RTRIM(GLBUH.FM) + ' ' + LEFT(GLBUH.IM, 1) + '. ' + LEFT(GLBUH.OT,1) + '.') AS GLBUH_FIO,
	RTRIM(GLBUH.PHONE) AS GL_PHONE,
	DD1.OGRN,
	DD1.OKATO,
	DD1.OKTMO,
	DD1.OKVED,
	DD1.OKPO,
	DD1.FSS_REG_NUM, --  ()  
	DD1.FSS_KOD_P, --  - ,    ,     ,       ;	
	DD1.FSS_KOD_DOP, --      
	DD1.OKOPF, ---    - ;
	DD1.OKFS, ---     ;
	DD1.PFNUMBER,
	DA.PINDEX, REGION = UPPER(DA.REGION), DA.REGCODE, RAION = UPPER(DA.RAION), GOROD = UPPER(DA.GOROD),
	NASEL = UPPER(DA.NASEL), STREET = UPPER(DA.STREET), DA.HOUSE, DA.KORP, DA.FLAT,
	TFOMS_RNUM = DD1.TFOMS_REG_NUM,
	TFOMS_KT = DD1.TFOMS_KT,
	TaxType = DD1.FSS_KP_PC1,
	TaxType2 = DD1.FSS_KP_PC2,
	TaxType3 = DD1.FSS_KP_PC3
INTO #DEP_DATA	
FROM DICTIONARY_DEPARTMENT DD1
	LEFT OUTER JOIN DICTIONARY_DEPARTMENT DD2 ON DD1.IMNS_LINK = DD2.LINK
	LEFT OUTER JOIN dbo.GetOtvFaceData(@LINK_DEP, '') chief on chief.link_dep = dd1.link
	LEFT OUTER JOIN dbo.GetOtvFaceData(@LINK_DEP, ' ') GLBUH ON GLBUH.link_dep = dd1.link
	LEFT JOIN DBO.DEP_ADRESS(@LINK_DEP) DA ON 1=1
WHERE DD1.LINK = @LINK_DEP

/*exec [dbo].[SA_SZVM_EXPORT_v2_40]       42451*/

DECLARE @TYPE_FORM VARCHAR(5), @NumDot INT
SELECT @TYPE_FORM = ISNULL(dbo.RN_GET_ATR_VALUE(@LINK, 'RB_VIEW_ATR_TYPE_KORR'),'')
--SET @NumDot = CASE WHEN ISNUMERIC(@NumDotC) =1 THEN CONVERT(INT,@NumDotC) ELSE 0 END

DECLARE @Cur0 CURSOR, @TAB_NUM TINYINT, @TAB_NAME VARCHAR(254), @Cur CURSOR, @Cur1 CURSOR, @NUM INT, @BLOK_NAME VARCHAR(254), @RAZDEL_NUM TINYINT, @RAZDEL_NAME VARCHAR(254)

DECLARE @lcFNAME varchar(254),
		@lcFidNAME VARCHAR(254),
        @GUID UNIQUEIDENTIFIER
SET @GUID = NEWID()


SELECT @lcFNAME ='_'+ PFNUMBER + '_000000_-_' + CONVERT(VARCHAR(8),ltrim(rtrim(replace(convert(varchar(10),@modify_date,102),'.',''))))  + '_'+ltrim(rtrim(@GUID))+'.XML' FROM #DEP_DATA
SELECT @lcFidNAME ='_'+ PFNUMBER + '_000000_-_' + CONVERT(VARCHAR(8),ltrim(rtrim(replace(convert(varchar(10),@modify_date,102),'.',''))))  + '_'+ltrim(rtrim(@GUID))+'' FROM #DEP_DATA

--SELECT convert(varchar(10),@modify_date,104)



INSERT INTO #OUTPUT (F_NAME, OUT_TEXT)
SELECT @lcFNAME, 'UTF-8' -- 
UNION ALL SELECT @lcFNAME, SPACE(0) + '<?xml version="1.0" encoding="UTF-8"?>'
UNION ALL SELECT @lcFNAME, SPACE(0) + '< xmlns="http://.//-/2016-04-01" xmlns:="http://.//2014-01-01" xmlns:="http://./" xmlns:xs="http://www.w3.org/2001/XMLSchema">'
UNION ALL SELECT @lcFNAME, SPACE(1) + '<->'



/**  **/
	UNION ALL SELECT @lcFNAME, SPACE(2) + '<>1</>'
	UNION ALL SELECT @lcFNAME, SPACE(2) + '<>'

		UNION ALL SELECT @lcFNAME, SPACE(3) + '<>'+RTRIM(LTRIM(PFNUMBER))+'</>' FROM #DEP_DATA
		UNION ALL SELECT @lcFNAME, SPACE(3) + '<>'+RTRIM(LTRIM(ORGNAME))+'</>' FROM #DEP_DATA
		UNION ALL SELECT @lcFNAME, SPACE(3) + '<>'+RTRIM(LTRIM(COALESCE(INN1,'')))+'</>' FROM #DEP_DATA
		UNION ALL SELECT @lcFNAME, SPACE(3) + '<>'+RTRIM(LTRIM(KPP1))+'</>' FROM #DEP_DATA
	UNION ALL SELECT @lcFNAME, SPACE(2) + '</>'
	UNION ALL SELECT @lcFNAME, SPACE(2) + '<>'
		UNION ALL SELECT @lcFNAME, SPACE(3) + '<>'+RTRIM(LTRIM(CONVERT(char(2),month(@End_Date))))+'</>' 
		UNION ALL SELECT @lcFNAME, SPACE(3) + '<>'+CONVERT(VARCHAR(4),@YEAR)+'</>'
	UNION ALL SELECT @lcFNAME, SPACE(2) + '</>'
	
--  /**  I **/



CREATE TABLE #TAB_1 (NUM_PP  INT identity(1,1) , FIO VARCHAR(254),FM VARCHAR(100), IM VARCHAR(100) , OT VARCHAR(100),  INSUR_NUM VARCHAR(15), INN VARCHAR(12))

CREATE TABLE #TEMP_1 (ROW_CODE VARCHAR(10), COL INT, SUMMA NUMERIC(18,2), STR_VAL VARCHAR(254))
INSERT INTO #TEMP_1  (ROW_CODE, COL, SUMMA, STR_VAL)
SELECT ROW_CODE, COL, SUMMA2, STR_VAL FROM DBO.SA_SAVED_REPORT_VIEW (@link, 1, DEFAULT, DEFAULT) T ORDER BY T.COL , t.ROW_CODE


INSERT INTO #TAB_1 ( FIO, FM, IM, OT, INSUR_NUM, INN)
SELECT DISTINCT
	--NUM_PP = (SELECT TOP 1 ROW_CODE FROM #TEMP_1 T WHERE T.COL = 2 AND T.ROW_CODE = T1.ROW_CODE),
	FIO = (SELECT TOP 1 STR_VAL FROM #TEMP_1 T WHERE T.COL = 2 AND T.ROW_CODE = T1.ROW_CODE),
	FM = (SELECT TOP 1 left(STR_VAL, PATINDEX ( '% %' , STR_VAL)) FROM #TEMP_1 T WHERE T.COL = 2 AND T.ROW_CODE = T1.ROW_CODE),
	IM = (SELECT TOP 1 SUBSTRING(STR_VAL,PATINDEX ( '% %' ,STR_VAL)+1,PATINDEX ( '% %' ,SUBSTRING(STR_VAL,PATINDEX ( '% %' ,STR_VAL)+1,LEN(STR_VAL)-PATINDEX ( '% %' ,STR_VAL)+1)))  FROM #TEMP_1 T WHERE T.COL = 2 AND T.ROW_CODE = T1.ROW_CODE),
	OT = (SELECT TOP 1 SUBSTRING(SUBSTRING(STR_VAL,PATINDEX ( '% %' ,STR_VAL)+1,LEN(STR_VAL)-PATINDEX ( '% %' ,STR_VAL)+1), PATINDEX('% %', SUBSTRING(STR_VAL,PATINDEX ( '% %' ,STR_VAL)+1,LEN(STR_VAL)-PATINDEX ( '% %' ,STR_VAL)+1)), LEN(SUBSTRING(STR_VAL,PATINDEX ( '% %' ,STR_VAL)+1,LEN(STR_VAL)-PATINDEX ( '% %' ,STR_VAL)+1))) FROM #TEMP_1 T WHERE T.COL = 2 AND T.ROW_CODE = T1.ROW_CODE),
	INSUR_NUM = (SELECT TOP 1 STR_VAL FROM #TEMP_1 T WHERE T.COL = 3 AND T.ROW_CODE = T1.ROW_CODE),
	INN = (SELECT TOP 1 STR_VAL FROM #TEMP_1 T WHERE T.COL = 4 AND T.ROW_CODE = T1.ROW_CODE)
FROM
	#TEMP_1 T1 


DECLARE  @DEP_LINK1 INT , @ID1 INT /* */ , @nYear int, @nMonth int
set @ID1 = 0
--SET @nYear = year(@dDate1)
--set @nMonth = month(@dDate1)


	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT)
	SELECT @lcFNAME, SPACE(2) + '<>'

SET @Cur1 = CURSOR FORWARD_ONLY
FOR select NUM_PP from #TAB_1  ORDER BY NUM_PP
	
OPEN @Cur1
FETCH NEXT FROM @Cur1 INTO @ID1

	WHILE (@@fetch_status <> -1)
	BEGIN
		IF (@@fetch_status <> -2)
		BEGIN
			INSERT INTO #OUTPUT (F_NAME, OUT_TEXT)
			SELECT @lcFNAME,SPACE(3) + '< ="'+RTRIM(LTRIM(STR(@ID1)))+'">' + CHAR(10)
								+ SPACE(4) + '<>' + CHAR(10)
									+ SPACE(5) + '<:>'+ RTRIM(LTRIM(COALESCE(FM,''))) +'</:>' + CHAR(10)
									+ SPACE(5) + '<:>'+RTRIM(LTRIM(COALESCE(IM,'')))+'</:>' + CHAR(10)
									+ SPACE(5) + '<:>'+ RTRIM(LTRIM(COALESCE(OT,''))) +'</:>' + CHAR(10)
								+ SPACE(4) + '</>' + CHAR(10)
								+ SPACE(4) + '<>'+ RTRIM(LTRIM(COALESCE(INSUR_NUM,''))) +'</>' + CHAR(10)
								+ SPACE(4) + (CASE WHEN COALESCE(INN,'') = '' THEN  '' 
										 WHEN len(COALESCE(INN,'')) <> 12  THEN    '' 
										 else '<>'+RTRIM(LTRIM(INN))+'</>' END )	 + CHAR(10)
						 + SPACE(3) + '</>' 
				FROM
					#TAB_1
				WHERE 
					NUM_PP = @ID1 
	
		END
		
		FETCH NEXT FROM @Cur1 INTO @ID1



	END

	CLOSE @Cur1
	DEALLOCATE @Cur1
	--exec [dbo].[SA_SZVM_EXPORT_v2_40]       42451

	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT) SELECT @lcFNAME, SPACE(2) + '</>'
	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT) SELECT @lcFNAME, SPACE(2) + '<>'+CONVERT(VARCHAR(10),ltrim(rtrim(replace(convert(varchar(10),@modify_date,126),'.',''))))+'</>'
	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT) SELECT @lcFNAME, SPACE(1) + '</->'
	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT)
	SELECT @lcFNAME, SPACE(1) + '<>'
	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT)
	SELECT @lcFNAME, SPACE(2) + '<:GUID>'+RTRIM(LTRIM(COALESCE(@GUID,'')))+'</:GUID>' + CHAR(10)
				   + SPACE(2) + '<:>'+CONVERT(VARCHAR(25),ltrim(rtrim(replace(convert(varchar(19),GETDATE(),126 ),'.','')+'+03:00')))+'</:>' + CHAR(10)
	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT)
	SELECT @lcFNAME, SPACE(1) + '</>'

	INSERT INTO #OUTPUT (F_NAME, OUT_TEXT) SELECT @lcFNAME, SPACE(0) + '</>'



SET NOCOUNT OFF


select * from #OUTPUT order by [ID]










GO


GRANT EXECUTE ON dbo.[SA_SZVM_EXPORT_v2_40] TO PUBLIC

GO



